SystemOrganization addCategory: #NoeTables!
SystemOrganization addCategory: #'NoeTables-Latin'!
SystemOrganization addCategory: #'NoeTables-Tests'!
SystemOrganization addCategory: #'NoeTables-Maths'!
SystemOrganization addCategory: #'NoeTables-Maths-Tests'!
SystemOrganization addCategory: #'NoeTables-Latin-Tests'!

SystemWindow subclass: #NoeTableMorph
	instanceVariableNames: 'pane problem lesson lastAnswerOk countDown counter textStyle'
	classVariableNames: 'DragonForm'
	poolDictionaries: ''
	category: 'NoeTables'!

!NoeTableMorph commentStamp: 'MathiasKegelmann 3/20/2010 14:23' prior: 0!
A NoeTableMorph is the main interface of the project.

Instance Variables
	countDown: a CountDown object that updates the counter
	counter:	 a StringMorph showing the counter
	lastAnswerOk:	 was the last answer right?
	lesson:    creates new problems
	pane:		 main pane
	problem:	 current problem of class NoeProblem
	textStyle: private style
!

!NoeTableMorph classSide methodsFor: 'morphic ui' stamp: 'MathiasKegelmann 11/12/2011 13:13'!
add: content to: morph at: pos
	morph addMorph: content fullFrame: (LayoutFrame fractions: pos)! !

!NoeTableMorph classSide methodsFor: 'morphic ui' stamp: 'MathiasKegelmann 11/12/2011 16:06'!
addConjugationLineInWindow: w forHelpPerson: personsAndEndings to: cont atY: y
	self
		add: ((w newLabel: personsAndEndings first)	emphasis: 1)
		to: cont
		at: (0 @ y corner: 0.3 @ (y + 0.3));
	
		add: ((w newLabel: personsAndEndings second) color: self green)
		to: cont
		at: (0.3 @ y corner: 0.5 @ (y + 0.3));	

		add: ((w newLabel: personsAndEndings third) color: self green)
		to: cont
		at: (0.5 @ y corner: 0.8 @ (y + 0.3)); 
		
		add: ((w newLabel: personsAndEndings fourth) emphasis: 1)
		to: cont
		at: (0.8 @ y corner: 1 @ (y + 0.3))! !

!NoeTableMorph classSide methodsFor: 'morphic ui' stamp: 'MathiasKegelmann 11/12/2011 16:18'!
addDeclensionLineInWindow: w forCases: cases to: cont atY: y.

	self	
		add: ((w newLabel: cases first) emphasis: 1)
		to: cont
		at: (0 @ y corner: 0.3 @ (y+0.25));

		add: (w newColumn: {
			(w newLabel: cases second first) color: Color blue . 
			w newLabel: cases second second . 
			(w newLabel: cases second third) color: Color red })
		to: cont
		at: (0.3 @ y corner: 0.5 @ (y+0.25));

		add: (w newColumn: {
			(w newLabel: cases third first) color: Color blue . 
			w newLabel: cases third second . 
			(w newLabel: cases third third) color: Color red })
		to: cont
		at: (0.5 @ y corner: 1 @ (y+0.25))
! !

!NoeTableMorph classSide methodsFor: 'morphic ui' stamp: 'MathiasKegelmann 11/12/2011 17:16'!
addLatinConjugationHelp: w 
	| cont green |
	cont := Morph new changeProportionalLayout layoutInset: 10.
	green := Color fromRgbTriplet: #(0 0.5 0).
	self 
		addConjugationLineInWindow: w forHelpPerson:  #('ich' '-o' '-mus' 'wir') to: cont atY: 0;
		addConjugationLineInWindow: w forHelpPerson:  #('du' '-s' '-tis' 'ihr') to: cont atY: 0.25;
		addConjugationLineInWindow: w forHelpPerson:  #('er' '-t' '-nt' 'sie') to: cont atY: 0.5;
		addConjugationLineInWindow: w forHelpPerson:  #('!!' '-' '-te' '') to: cont atY: 0.75.
				
	w
		addMorph: cont
		frame: (0 @ 0.7 corner: 1 @ 0.95)! !

!NoeTableMorph classSide methodsFor: 'morphic ui' stamp: 'MathiasKegelmann 11/12/2011 17:16'!
addLatinDeclensionHelp: w 
	| cont |
	cont := Morph new changeProportionalLayout layoutInset: 10.
	self
		addDeclensionLineInWindow: w forCases: #('wer?' ('-us / (-e)' '-um' '-a') ('-i' '-a' '-ae')) to: cont atY: 0;
		addDeclensionLineInWindow: w forCases: #('wen?' ('-um' '-um' '-am') ('-os' '-a' '-as')) to: cont atY: 0.3;
		addDeclensionLineInWindow: w forCases: #('wem?' ('-o' '-o' '-ae') ('-is' '-is' '-is')) to: cont atY: 0.6.

	self
		add: (w newRow: {
			(w newLabel: 'mnnlich/Maskulinum') emphasis: 2; color: Color blue. 
			(w newLabel: 'schlich/Neutrum') emphasis: 2. 
			(w newLabel: 'weiblich/Feminum') emphasis: 2; color: Color red
		})
		to: cont
		at: (0 @ 0.9 corner: 1 @ 1).

	w
		addMorph: cont
		frame: (0 @ 0 corner: 1 @ 0.65)! !

!NoeTableMorph classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/20/2010 14:20'!
dragonForm
	"The dragon form was created as follows:
	
	dragon := Form fromFileNamed: 'c:\tmp\dragon.jpg'.
	dragon2 := dragon scaledToSize: 200@250.
	dragon2 explore.

	Then in the form explorer:
	
	self storeOn: Transcript.
	Transcript show: ''; cr.
	"
	DragonForm ifNil: [ self initializeDragonForm	].
	^ DragonForm.! !

!NoeTableMorph classSide methodsFor: 'examples' stamp: 'MathiasKegelmann 5/6/2010 21:34'!
example
	^ self runForLesson: (NoeFlexibleLesson newWithPlan: {
	"	ComplementProblemGenerator .
		SquareProblemGenerator . 
		ComplementProblemGenerator . "
		SmallChangeBaseFiveProblemGenerator .
		SolidsProblemGenerator .
	"	ComplementProblemGenerator . "
		ChangeBaseFiveProblemGenerator .
		ComplementOneHundredProblemGenerator .
		AgeProblemGenerator .
		ShuffledSquareProblemGenerator .
		FullChangeProblemGenerator .
		ComplementOneThousandProblemGenerator .
		AgeReverseProblemGenerator .
		CombinedAgeProblemGenerator 
		}).! !

!NoeTableMorph classSide methodsFor: 'instance creation' stamp: 'MathiasKegelmann 2/27/2010 00:08'!
forLesson: lesson
	^ self new lesson: lesson.! !

!NoeTableMorph classSide methodsFor: 'instance creation' stamp: 'MathiasKegelmann 2/27/2010 00:08'!
forProblem: problem
	^ self new problem: problem.! !

!NoeTableMorph classSide methodsFor: 'morphic ui' stamp: 'MathiasKegelmann 11/12/2011 15:56'!
green
	^ Color fromRgbTriplet: #(0 0.5 0)! !

!NoeTableMorph classSide methodsFor: 'instance creation' stamp: 'MathiasKegelmann 3/21/2010 11:21'!
initializeDragonForm
	DragonForm := (Form
	extent: 103@104
	depth: 16
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2088991777 2082569249 1478514720 1478514720 1478514720 1478514720 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082560032 1478514720 1478514720 1478514720 1478514720 1478514720 1478523937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082560032 1478514720 1478523937 2082569249 2082569249 2082569249 1478514720 1478514720 1478514720 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2088991777 2082569249 2082569249 1478514720 1478514720 2082569249 2082569249 2082569249 2082569249 2082569249 1478514720 1478514720 1478514720 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082560032 1478514720 1478514720 2082569347 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082560032 1478514720 1478492160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 1478514720 1478514720 1478523937 2082569347 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082560032 1478514720 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2088982560 1478514720 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082560032 1478492160 0 0 0 0 0 0 0 0 1593270007 1593245696 0 0 0 0 0 0 0 2082569249 2082537473 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 1478514720 1478523937 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082560032 1478514720 0 0 0 0 0 0 0 24311 1593270007 1593270007 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 1478514720 2082569249 2082569249 2082569249 2088991777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 2082569249 2082569249 1478514720 1478492160 0 0 0 0 0 0 1593270007 1593270007 1593270007 1593270007 1593270007 0 0 0 0 0 2082569249 97313 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 31777 2082560032 1478514720 2082569249 2082569249 2082569347 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 31777 1478514720 1478492160 0 0 0 0 0 0 1593270007 1593270007 1593270007 1593270007 1593270007 1593245696 0 0 0 31777 2082569249 65537 97313 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 2082569249 1478514720 1478523937 2082569249 2088991875 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 2082560032 1478492160 0 0 0 0 0 24311 1593270007 1593270007 1593270007 1593270007 1593270007 1593270007 0 0 0 2082569249 2082537473 2082537473 97313 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 31777 2082569249 1478514720 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 1478492160 0 0 0 0 0 24311 1593270007 1593270007 1593270007 1593270007 1593270007 1593270007 1593245696 0 0 2082569249 2082537473 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 31777 2082560032 1478514720 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 24311 1593270007 1593270007 1593270007 1593270007 1593270007 1593270007 1593245696 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 2082569249 2082560032 1478523937 2082569249 2082560032 1478514720 1478514720 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 24311 1593270007 1593270007 1593270007 1593270007 1593270007 1593270007 1593245696 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 2082569249 2082560032 1478523937 2082569249 1478514720 1478514720 1478514720 1478514720 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 1593270007 1593270007 1593270007 1593270007 1593270007 1593270007 1593245696 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 2082569249 2082560032 1478523937 2082560032 1478514720 2082569249 2082569249 1478514720 1478514720 1478514720 1478514720 1478523937 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 24311 1593270007 1593270007 1593270007 1593270007 1593270007 1593270007 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 31777 2082569249 2082560032 1478523937 1478514720 1478523937 2082569249 2082569249 2082560032 1478514720 1478514720 1478514720 1478514720 1478523937 0 0 0 0 0 0 0 0 0 0 0 0 0 24311 1593270007 1593270007 1593270007 1593270007 1593270007 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 2082537472 0 0 0 0 0 31777 2082569249 1478514720 1478514720 1478514720 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 1478514720 1478514720 1478514720 0 0 0 0 0 0 0 0 0 0 0 0 0 1593270007 1593270007 1593270007 1593270007 1593270007 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 31777 2082569249 1478514720 2082560032 1478514720 1478523937 2082569249 2082569249 2082569249 2082569249 2082569249 0 31777 1478514720 1478514720 1478492160 0 0 0 0 0 0 0 0 0 0 0 0 24311 1593270007 1593270007 1593270007 1593270007 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 2082569249 2082569249 2082569249 2082569249 2082569249 0 31777 0 0 0 0 31777 2082560032 1478523937 1478514720 1478514720 1478514720 2082569249 2082569249 2082569249 2082569249 0 0 0 0 1478514720 1478492160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1593270007 1593270007 1593270007 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 2082569249 0 31777 2082569249 1478514720 1478514720 2082569249 1478514720 1478523937 2082569249 2082569249 2082537472 0 0 0 0 22560 1478492160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 24311 1593270007 1593270007 1415599200 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 31777 2082569249 1478514720 1478523937 2082569249 2082560032 1478523937 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 1415599200 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 31777 2082569249 1478514720 2082569249 2082569249 2082560032 1478514720 1478523937 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 1415599200 2082569249 2080309249 2082569249 2082569249 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 31777 2082569249 1478514720 2082569249 2082569249 2082569249 2082560032 1478514720 1478523937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082537473 1478492161 2082569249 2082537472 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 2082569249 2082560032 1478523937 2082569249 2082569249 2082569249 2082560032 1478514720 1478492160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082537473 2080309249 2082569249 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569347 2088991875 2088991875 2082569249 0 2082569249 1478514720 1478523937 2082569249 2082569249 2082569249 2082569249 1478514720 1478514720 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569215 1478523903 2082537472 0 0 0 0 0 0 31777 2082569249 2082569249 2082569347 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2088991777 1478514720 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 1478514720 1478514720 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082560032 1478514720 1478492160 0 0 0 0 0 0 31777 2082569249 2088991777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569347 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082560032 1478514720 1478492160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1478523903 1478514720 2082569249 2082537472 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 31777 2082569249 2082560032 1478492160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1478514720 1478514720 2082569249 2082537472 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 2082569249 2082560032 1478492160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1478514720 1478514720 1478523937 2082537472 0 0 0 0 0 2088991777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569347 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1478523937 2082560032 1478523937 2082537472 0 0 0 0 31875 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2088960000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1478523937 2082560032 1478523937 2082569249 0 0 0 0 2088991777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569347 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 22560 1478523937 2082560032 1478514720 2082569249 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 1478492160 0 0 0 0 0 0 0 0 0 1478514720 1478523937 2082569249 1478514720 2082569249 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1478523937 2082569249 0 0 0 0 0 0 0 0 22560 1478514720 2082569249 2082569249 1478514720 1478523937 2082537472 0 0 2088991777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569347 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1478523937 2082569249 2082537472 0 0 0 0 0 0 0 1478514720 1478514720 2082569249 2082569249 1478514720 1478523937 2082537472 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1478514720 1478523937 2082569249 0 0 0 0 0 0 22560 1478514720 2082569249 2082569249 2082569249 1478514720 1478523937 2082537472 0 0 2145026010 2145026010 2145026010 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2088960000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1478514720 1478514720 2082569249 2082537472 0 0 0 0 0 1478514720 1478523937 2082569249 1478523937 2082569249 1478514720 1478523937 2082537472 0 32730 2145026010 2145026010 2145026010 2145026010 2145026010 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2088960000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1478514720 1478514720 1478523937 2082569249 2082537472 0 0 2082569249 2082569249 2082569249 2082569249 2082560032 1478523937 2082560032 1478514720 1478523937 2082537472 0 32730 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 22560 1478514720 1478514720 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082560032 1478514720 2082569249 2082560032 1478524332 2108456364 2108424192 0 32730 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1478514720 1478524332 2108456364 2108456364 2108455969 2082569249 2082560032 1478523937 2082569249 1478514720 1478514720 2082569249 1478514720 1478524332 2108456364 2108455969 0 32730 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145025057 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1478514720 1478524332 2108456364 2108456364 2108456364 1478514720 1478514720 2082569249 2082560032 1478514720 1478523937 2082569249 1478514720 1478524332 2108456364 2082569249 2082537472 32730 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145025057 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 22560 1478514720 1478514720 1478524332 2108446752 1478523937 2082569249 2082569249 1478514720 1478514720 2082569249 2082560032 1478514720 1478514720 2108456364 2108455969 2082569249 32730 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145025057 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 22560 1478514720 1478514720 1478514720 2082569249 2082569249 1478514720 1478514720 1478514720 2082569249 1478514720 1478514720 1478514720 1478524332 2108456364 2082569249 2082570202 2145026010 1478524890 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1478523937 2082569249 1478514720 1478514720 1478514720 1478523937 2082569249 1478514720 1478514720 1478514720 1478514720 2108456364 1478523937 2082560032 2082569249 1478514720 1478524890 2145026010 2145026010 2145026010 2145026010 2145026010 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082560032 1478514720 1478514720 2082569249 2082569249 2082560032 1478514720 1478514720 1478514720 1478514720 2108456364 2108455969 2082569249 2082569249 1478514720 1478524890 2145026010 2145026010 2145026010 2145026010 2145026010 2145025057 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2088991777 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 1478514720 1478514720 2082569249 2082569249 2082569249 1478514720 1478492160 1478514720 1478514720 1478514720 1478524332 2108456364 2082569249 2082569249 2082569249 1478524890 2145026010 2145026010 2145026010 2145026010 2145026010 2145025057 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 22560 2082569249 2082560032 1478523937 2082569249 1478514720 2082569249 1478514720 1478492160 22560 1478514720 1478514720 1478524332 2108456364 1478523937 2082569249 2082569249 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 1478514720 2082569249 2082560032 1478514720 2082569249 1478514720 1478514720 0 0 1478514720 1478514720 1478514720 1478514720 1478514720 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082560032 1478523937 2082569249 1478514720 1478514720 2082569249 1478514720 1478514720 0 0 0 0 1478514720 1478514720 32730 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145025057 2082569249 2082569249 2082569249 2082569249 2082569249 2082570202 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 1478514720 2082569249 2082560032 1478514720 1478514720 2082569249 1478514720 1478514720 1478492160 0 0 0 0 0 0 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082560032 1478514720 2082569249 1478514720 1478514720 2108446752 2082569249 1478514720 1478524332 2108446752 0 0 0 0 0 0 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145025057 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 1478523937 2082569249 1478514720 1478523937 2082569249 1478514720 1478514720 2108456364 2082569249 1478514720 1478524332 2108446752 1478492160 0 0 0 0 0 32730 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 31777 2082569249 2082560032 1478514720 31777 2082560032 1478514720 1478514720 2108456364 2082569249 1478514720 1478524332 2108446752 1478492160 0 0 0 0 0 0 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145025057 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 1478514720 0 2082569249 2082560032 1478514720 1478524332 2108456364 2082569249 1478514720 1478514720 2108456364 1478514720 0 0 0 0 0 0 0 2082569249 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145025057 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 31777 2082569249 2082569249 2082560032 1478514720 0 0 2082569249 1478514720 1478514720 2108456364 2108446752 2082569249 1478514720 1478514720 2108456364 1478514720 0 0 0 0 0 0 0 2082569249 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145026010 2145025057 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 2082569249 2082569249 2082537472 0 0 0 2082569249 2082560032 1478514720 2108456364 2108456364 1478514720 2082569249 1478514720 1478514720 2108456364 2108446752 0 0 0 0 0 0 31777 2082569249 2082570202 2145026010 2082570202 2145026010 2145026010 2145026010 2145026010 2145026010 2145025057 2082569249 2082569249 2082569249 2082569249 65536 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 31777 0 0 0 0 0 2082569249 2082560032 1478514720 2108456364 1478514720 1478492160 2082569249 1478514720 1478514720 1478524332 2108446752 1478492160 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082570202 2145026010 2145026010 2145026010 2145026010 2145026010 2144993280 2082569249 2082569249 2082569249 2082537473 65537 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 31777 2082569249 1478514720 1478514720 1478514720 1478492160 0 2082569249 2082560032 1478514720 1478514720 2108456364 1478492160 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082537472 0 2082569249 2082569249 2082569249 2082569249 2082537472 2082569249 2082537472 1 0 1 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 2082569249 2082569249 1478514720 1478514720 1478492160 0 0 31777 2082569249 2082560032 1478514720 1478514720 1478492160 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082537472 0 2082569249 2082569249 2082569249 2082569249 2082537472 1 65536 1 65536 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 31777 2082569249 1478514720 1478514720 1478492160 0 0 0 0 2082569249 2082569249 2082560032 1478514720 1478514720 1478492160 0 0 0 0 31777 2082569249 2082569249 2082569249 2082537472 0 2082569249 2082569249 2082569249 2082569249 2082537472 1 65536 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 31777 2082560032 1478514720 0 0 0 0 0 0 0 2082569249 2082569249 1478514720 1478514720 1478514720 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082537472 0 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 31777 2082560032 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 31777 2082569249 2082569249 2082569249 2082569249 0 0 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 31777 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 0 0 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082537472 0 31777 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 0 31777 2082569249 2082569249 2082569249 2082569249 0 0 0 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 97313 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 31777 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2088991875 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 97313 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 31777 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569347 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 65537 31777 2082569249 2082569249 2082569249 2082569249 2082537472 0 2082569249 2082537472 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 0 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569347 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 0 0 0 0 0 1 65536 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569347 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 1 65536 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 31875 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082537472 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 31875 2082569249 2082569249 2082569249 2082569249 2082569249 2082569347 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569347 2082569249 2082569249 2082569249 2082537472 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2088991875 2088991777 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 97313 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 31777 2082569249 2082537472 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 2082537472 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65537 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 65536 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082569249 2082569249 2088991777 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2082569249 2082569347 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 2082537472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 31777 2082569249 2082569249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!NoeTableMorph classSide methodsFor: 'examples-latin' stamp: 'MathiasKegelmann 11/12/2011 17:10'!
latinAll
	^ self runForLesson: (NoeFlexibleLesson newWithPlan: {
		GermanLatinConjugationProblemGenerator .
	
		CombinedSOaVProblemGenerator .
	
		CasesDictionaryProblemGenerator .
	
		CombinedSOdVProblemGenerator .
		CombinedSOVProblemGenerator .

		DeclensionProblemGenerator .
	
		GiveSentenceProblemGenerator .
		CombinedSOOVProblemGenerator .
		
		ConjugationDictionaryProblemGenerator .
		ConjugationProblemGenerator .
		
		DeclensionAnalysisProblemGenerator .
		ConjugationAnalysisProblemGenerator .
		BasicVerbNounAnalysisProblemGenerator 
		}).! !

!NoeTableMorph classSide methodsFor: 'examples-latin' stamp: 'MathiasKegelmann 11/12/2011 17:10'!
latinAnalysis
	^ self runForLesson: (NoeFlexibleLesson newWithPlan: {
			DeclensionAnalysisProblemGenerator .
			ConjugationAnalysisProblemGenerator .
			BasicVerbNounAnalysisProblemGenerator 
		}).! !

!NoeTableMorph classSide methodsFor: 'examples-latin' stamp: 'MathiasKegelmann 11/12/2011 17:11'!
latinGrammar
	^ self runForLesson: (NoeFlexibleLesson newWithPlan: {
		CasesDictionaryProblemGenerator .
		DeclensionProblemGenerator .
		ConjugationDictionaryProblemGenerator .
		ConjugationProblemGenerator .
"		
		DeclensionAnalysisProblemGenerator .
		ConjugationAnalysisProblemGenerator .
		BasicVerbNounAnalysisProblemGenerator 
"		}).! !

!NoeTableMorph classSide methodsFor: 'morphic ui' stamp: 'MathiasKegelmann 11/12/2011 17:16'!
latinHelp
	| w |
	w := StandardWindow new.
	self addLatinDeclensionHelp: w.
	self addLatinConjugationHelp: w.
	w openInWorldExtent: 440@455! !

!NoeTableMorph classSide methodsFor: 'examples-latin' stamp: 'MathiasKegelmann 11/12/2011 15:31'!
latinTranslate
	^ self runForLesson: (NoeFlexibleLesson newWithPlan: {
		GermanLatinConjugationProblemGenerator .
		CombinedSOaVProblemGenerator .
		CombinedSOdVProblemGenerator .
		CombinedSOVProblemGenerator .
		GiveSentenceProblemGenerator .
		CombinedSOOVProblemGenerator .
		}).! !

!NoeTableMorph classSide methodsFor: 'menu' stamp: 'MathiasKegelmann 11/12/2011 17:12'!
menuCommandOn: aBuilder
	<worldMenu>
	(aBuilder item: 'Latein') withSeparatorAfter.
	(aBuilder item: 'bersetzen')
		action: [self latinTranslate]; 
		parent: #Latein.
	(aBuilder item: 'Grammatik')
		action: [self latinGrammar]; 
		parent: #Latein.
	(aBuilder item: 'Formenbestimmung')
		action: [self latinAnalysis]; 
		parent: #Latein.
	(aBuilder item: 'Alles')
		action: [self latinAll]; 
		parent: #Latein;
		withSeparatorAfter.
	(aBuilder item: 'Spickzettel')
		action: [self latinHelp]; 
		parent: #Latein.
! !

!NoeTableMorph classSide methodsFor: 'running' stamp: 'MathiasKegelmann 3/5/2010 20:21'!
run: aNoeTableMorph
	aNoeTableMorph 
		openInWorld;
		resizeWindow.
	^aNoeTableMorph.! !

!NoeTableMorph classSide methodsFor: 'running' stamp: 'MathiasKegelmann 3/6/2010 17:17'!
runForLesson: lesson
	^ self run: (self forLesson: lesson).! !

!NoeTableMorph classSide methodsFor: 'running' stamp: 'MathiasKegelmann 3/6/2010 17:18'!
runForProblemGeneratorClass: problemGeneratorClass
	^ self runForLesson: (NoeLesson newWithProblemGenerator: problemGeneratorClass new).! !

!NoeTableMorph classSide methodsFor: 'examples' stamp: 'MathiasKegelmann 3/6/2010 22:25'!
squaresExample
	^ self runForProblemGeneratorClass: ShuffledSquareProblemGenerator.! !

!NoeTableMorph methodsFor: 'configuration' stamp: 'MathiasKegelmann 3/12/2010 07:27'!
basicTime
	"time in seconds for a problem of hardness one"
	^ 10! !

!NoeTableMorph methodsFor: 'private' stamp: 'MathiasKegelmann 3/17/2010 18:24'!
buttonFont 
	^ textStyle fontOfPointSize: 14.! !

!NoeTableMorph methodsFor: 'event handling' stamp: 'MathiasKegelmann 3/11/2010 23:20'!
checkAnswer: anAnswer
	countDown stop.
	lastAnswerOk := problem isCorrectAnswer: anAnswer.
	lastAnswerOk
		ifTrue: [ self inform: 'Richtig!!' ]
		ifFalse: [ self inform: 'Leider falsch...' ].
	self gotoNextProblem! !

!NoeTableMorph methodsFor: 'private' stamp: 'MathiasKegelmann 3/17/2010 18:22'!
counterFont 
	^ textStyle fontOfPointSize: 12.! !

!NoeTableMorph methodsFor: 'initialize-release' stamp: 'MathiasKegelmann 3/11/2010 23:12'!
delete
	countDown stop.
	super delete.! !

!NoeTableMorph methodsFor: 'stepping' stamp: 'MathiasKegelmann 3/6/2010 17:33'!
gotoNextProblem
	"...which could be the same problem as the previous one if the answer was wrong.
	The problem is determined by the lesson."
	self problem: self nextProblem.! !

!NoeTableMorph methodsFor: 'initialize-release' stamp: 'MathiasKegelmann 8/3/2010 00:35'!
initialize
	"I am a subclass of SystemWindow rather than StanardWindow as the latter is not available in eToys."
	super initialize.
	self initializePane;
		initializeMorph;
		initializeFonts;
		initializeCounter! !

!NoeTableMorph methodsFor: 'initialize-release' stamp: 'MathiasKegelmann 3/17/2010 13:22'!
initializeCounter
	counter := StringMorph contents: '-' font: self counterFont.
	countDown := CountDown new! !

!NoeTableMorph methodsFor: 'initialize-release' stamp: 'MathiasKegelmann 8/3/2010 00:35'!
initializeFonts
	textStyle := TextStyle default copy.
	"textStyle addNewFontSize: 12.
	textStyle addNewFontSize: 14.
	textStyle addNewFontSize: 16."! !

!NoeTableMorph methodsFor: 'initialize-release' stamp: 'MathiasKegelmann 3/17/2010 13:21'!
initializeMorph
	self
		setLabel: 'Noemi Tables';
		addMorph: pane frame: (0 @ 0 corner: 1 @ 1)! !

!NoeTableMorph methodsFor: 'initialize-release' stamp: 'MathiasKegelmann 3/17/2010 13:20'!
initializePane
	pane := Morph new.
	pane
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		listCentering: #center;
		cellInset: 4;
		layoutInset: 10;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap! !

!NoeTableMorph methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/6/2010 22:59'!
lesson: aLesson
	lesson := aLesson.
	lesson levelChangeObserver: [self inform: 'Prima!!' , Character cr asString , 'Weiter mit dem nchsten Level...'].
	self problem: lesson nextProblem.! !

!NoeTableMorph methodsFor: 'private' stamp: 'MathiasKegelmann 3/12/2010 07:38'!
lessonTimeFactor 
	^ lesson isNil ifTrue: [1] ifFalse: [lesson hardness]. ! !

!NoeTableMorph methodsFor: 'drawing' stamp: 'MathiasKegelmann 3/17/2010 18:27'!
makeButton: option
	| button |
	button := SimpleButtonMorph new.
	button label: option asString font: self buttonFont.
	^button! !

!NoeTableMorph methodsFor: 'stepping' stamp: 'MathiasKegelmann 3/6/2010 17:28'!
nextProblem
	"Get the next problem or nil"
	^ lesson notNil 
		ifTrue: [lesson nextProblem: lastAnswerOk]
		ifFalse: [nil].! !

!NoeTableMorph methodsFor: 'stepping' stamp: 'MathiasKegelmann 3/12/2010 07:29'!
problem: aProblem
	aProblem  isNil ifTrue: [
		self inform: 'Geschafft!!'.
		self delete]
	ifFalse: [
		problem := aProblem.
		countDown 
			countdownFrom: self timeForProblem 
			target: self 
			onTimeout: #timeout 
			onUpdate: #updateCounter:.
		self refreshGUI].! !

!NoeTableMorph methodsFor: 'private' stamp: 'MathiasKegelmann 3/17/2010 18:23'!
problemFont 
	^ textStyle fontOfPointSize: 16.! !

!NoeTableMorph methodsFor: 'drawing' stamp: 'MathiasKegelmann 3/18/2010 22:00'!
refreshButtonMorphs
	problem options
		do:
			[ :option | 
			pane
				addMorphBack:
					((self makeButton: option)
						target: self;
						actionSelector: #checkAnswer:;
						arguments: {option}) ]! !

!NoeTableMorph methodsFor: 'drawing' stamp: 'MathiasKegelmann 3/18/2010 22:19'!
refreshCounterMorph
	counter contents: '-'.
	pane addMorphBack: counter! !

!NoeTableMorph methodsFor: 'drawing' stamp: 'MathiasKegelmann 3/5/2010 01:48'!
refreshGUI
	self refreshMorphs; resizeWindow.! !

!NoeTableMorph methodsFor: 'drawing' stamp: 'MathiasKegelmann 3/18/2010 22:19'!
refreshMorphs
	pane removeAllMorphs.
	self refreshProblemTextMorphs;
		refreshCounterMorph;
		refreshButtonMorphs! !

!NoeTableMorph methodsFor: 'drawing' stamp: 'MathiasKegelmann 3/18/2010 23:32'!
refreshProblemTextMorphs
	| lines |
	lines := (problem text withNoLineLongerThan: 40) findTokens: Character cr.
	lines do: [:line | pane addMorphBack: (StringMorph contents: line font: self problemFont)]! !

!NoeTableMorph methodsFor: 'drawing' stamp: 'MathiasKegelmann 3/5/2010 01:51'!
resizeWindow
	| paneExtent labelExtend |
	paneExtent  := pane minExtent.
	labelExtend := self getRawLabel minExtent.
	self extent: (paneExtent x max: labelExtend x) @ (paneExtent y + labelExtend y) + 20.! !

!NoeTableMorph methodsFor: 'private' stamp: 'MathiasKegelmann 4/24/2011 12:09'!
showDragon
	pane addMorph: (ImageMorph withForm: self class dragonForm).
	self resizeWindow! !

!NoeTableMorph methodsFor: 'stepping' stamp: 'MathiasKegelmann 3/12/2010 07:36'!
timeForProblem
	^ (self basicTime * (self lessonTimeFactor) + 1) rounded.! !

!NoeTableMorph methodsFor: 'event handling' stamp: 'MathiasKegelmann 3/20/2010 18:32'!
timeout
	WorldState addDeferredUIMessage: [
		self showDragon.
		self inform: 'Die Zeit ist um!!'.
		lastAnswerOk := false.
		self gotoNextProblem].! !

!NoeTableMorph methodsFor: 'event handling' stamp: 'MathiasKegelmann 3/12/2010 07:40'!
updateCounter: n
	WorldState addDeferredUIMessage: [
		counter contents: '(Drache... ', n asString, ')'].
! !

!Collection methodsFor: '*NoeTables' stamp: 'MathiasKegelmann 11/6/2011 22:00'!
cartesianProduct
	"of a collection of collections"
	^ self allButFirst 
		inject: (self first collect: [:x | {x}])
		into: [:threads :coll | coll
				inject: #()
				into: [:newThreads :x | newThreads, 
						(threads collect: [:t | t , {x}])]]! !

TestCase subclass: #AbstractChangeProblemGeneratorTest
	instanceVariableNames: 'generator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Maths-Tests'!

!AbstractChangeProblemGeneratorTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 3/19/2010 22:23'!
setUp
	generator := AbstractChangeProblemGenerator new.! !

!AbstractChangeProblemGeneratorTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 3/19/2010 22:19'!
setupMorphs 
	generator := AbstractChangeProblemGenerator new.! !

!AbstractChangeProblemGeneratorTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 3/19/2010 22:21'!
testBasicCase
	self assert: '2,35 EUR' equals: (generator stringFromEuros: 2 andCents: 35).! !

!AbstractChangeProblemGeneratorTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 3/19/2010 22:20'!
testSmallCents
	self assert: '2,01 EUR' equals: (generator stringFromEuros: 2 andCents: 1).! !

!AbstractChangeProblemGeneratorTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 3/19/2010 22:24'!
testZero
	self assert: '0,00 EUR' equals: (generator stringFromEuros: 0 andCents: 0).! !

!AbstractChangeProblemGeneratorTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 3/19/2010 22:21'!
testZeroEuros
	self assert: '0,56 EUR' equals: (generator stringFromEuros: 0 andCents: 56).! !

TestCase subclass: #AbstractSentenceProblemGeneratorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin-Tests'!

!AbstractSentenceProblemGeneratorTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:03'!
testGermanThridPersonPlural
	|sut|
	sut := AbstractSentenceProblemGenerator new.
	sut germanVerb: (GermanVerb withRoot: 'kenn').
	self assert: 'kennen' equals: sut germanThirdPersonPluralVerb ! !

!AbstractSentenceProblemGeneratorTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:02'!
testGermanThridPersonPluralReflexive
	|sut|
	sut := AbstractSentenceProblemGenerator new.
	sut germanVerb: (GermanReflexiveVerbNoE withRoot: 'nher').
	self assert: 'nhern sich' equals: sut germanThirdPersonPluralVerb ! !

!AbstractSentenceProblemGeneratorTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:02'!
testGermanThridPersonSingular
	|sut|
	sut := AbstractSentenceProblemGenerator new.
	sut germanVerb: (GermanVerb withRoot: 'kenn').
	self assert: 'kennt' equals: sut germanThirdPersonVerb.! !

!AbstractSentenceProblemGeneratorTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:02'!
testGermanThridPersonSingularReflexive
	|sut|
	sut := AbstractSentenceProblemGenerator new.
	sut germanVerb: (GermanReflexiveVerbNoE withRoot: 'nher').
	self assert: 'nhert sich' equals: sut germanThirdPersonVerb.! !

TestCase subclass: #GermanFeminineNounDoubleNTest
	instanceVariableNames: 'word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin-Tests'!

!GermanFeminineNounDoubleNTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:53'!
setUp
	word := GermanFeminineNoun withRoot: 'Sklavin'.! !

!GermanFeminineNounDoubleNTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:53'!
testAccusativePlural
	self assert: 'die Sklavinnen' equals: word accusativePlural ! !

!GermanFeminineNounDoubleNTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:53'!
testAccusativeSingular
	self assert: 'die Sklavin' equals: word accusativeSingular ! !

!GermanFeminineNounDoubleNTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:53'!
testDativePlural
	self assert: 'den Sklavinnen' equals: word dativePlural! !

!GermanFeminineNounDoubleNTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:53'!
testDativeSingular
	self assert: 'der Sklavin' equals: word dativeSingular ! !

!GermanFeminineNounDoubleNTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:54'!
testNominativePlural
	self assert: 'die Sklavinnen' equals: word nominativePlural.! !

!GermanFeminineNounDoubleNTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:53'!
testNominativeSingular
	self assert: 'die Sklavin' equals: word nominativeSingular.! !

!GermanFeminineNounDoubleNTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:54'!
testVocativePlural
	self assert: 'Sklavinnen' equals: word vocativePlural! !

!GermanFeminineNounDoubleNTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:54'!
testVocativeSingular
	self assert: 'Sklavin' equals: word vocativeSingular ! !

TestCase subclass: #GermanFeminineNounTest
	instanceVariableNames: 'word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin-Tests'!

!GermanFeminineNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:30'!
setUp
	word := GermanFeminineNoun withRoot: 'Frau'.! !

!GermanFeminineNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:27'!
testAccusativePlural
	self assert: 'die Frauen' equals: word accusativePlural ! !

!GermanFeminineNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:27'!
testAccusativeSingular
	self assert: 'die Frau' equals: word accusativeSingular ! !

!GermanFeminineNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:27'!
testDativePlural
	self assert: 'den Frauen' equals: word dativePlural! !

!GermanFeminineNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:27'!
testDativeSingular
	self assert: 'der Frau' equals: word dativeSingular ! !

!GermanFeminineNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:27'!
testNominativePlural
	self assert: 'die Frauen' equals: word nominativePlural.! !

!GermanFeminineNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:27'!
testNominativeSingular
	self assert: 'die Frau' equals: word nominativeSingular.! !

!GermanFeminineNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:27'!
testVocativePlural
	self assert: 'Frauen' equals: word vocativePlural! !

!GermanFeminineNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:27'!
testVocativeSingular
	self assert: 'Frau' equals: word vocativeSingular ! !

TestCase subclass: #GermanMasculineFixedNounTest
	instanceVariableNames: 'word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin-Tests'!

!GermanMasculineFixedNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:52'!
setUp
	word := GermanMasculineFixedNoun withRoot: 'Rmer'.! !

!GermanMasculineFixedNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:52'!
testAccusativePlural
	self assert: 'die Rmer' equals: word accusativePlural ! !

!GermanMasculineFixedNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:52'!
testAccusativeSingular
	self assert: 'den Rmer' equals: word accusativeSingular ! !

!GermanMasculineFixedNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 18:15'!
testDativePlural
	self assert: 'den Rmern' equals: word dativePlural! !

!GermanMasculineFixedNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:52'!
testDativeSingular
	self assert: 'dem Rmer' equals: word dativeSingular ! !

!GermanMasculineFixedNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:52'!
testNominativePlural
	self assert: 'die Rmer' equals: word nominativePlural.! !

!GermanMasculineFixedNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:52'!
testNominativeSingular
	self assert: 'der Rmer' equals: word nominativeSingular.! !

!GermanMasculineFixedNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:52'!
testVocativePlural
	self assert: 'Rmer' equals: word vocativePlural! !

!GermanMasculineFixedNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:52'!
testVocativeSingular
	self assert: 'Rmer' equals: word vocativeSingular ! !

TestCase subclass: #GermanMasculineNNounTest
	instanceVariableNames: 'word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin-Tests'!

!GermanMasculineNNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:48'!
setUp
	word := GermanMasculineNNoun withRoot: 'Sklave'.! !

!GermanMasculineNNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:17'!
testAccusativePlural
	self assert: 'die Sklaven' equals: word accusativePlural ! !

!GermanMasculineNNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:17'!
testAccusativeSingular
	self assert: 'den Sklaven' equals: word accusativeSingular ! !

!GermanMasculineNNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:17'!
testDativePlural
	self assert: 'den Sklaven' equals: word dativePlural! !

!GermanMasculineNNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:17'!
testDativeSingular
	self assert: 'dem Sklaven' equals: word dativeSingular ! !

!GermanMasculineNNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:17'!
testNominativePlural
	self assert: 'die Sklaven' equals: word nominativePlural.! !

!GermanMasculineNNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:17'!
testNominativeSingular
	self assert: 'der Sklave' equals: word nominativeSingular.! !

!GermanMasculineNNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:17'!
testVocativePlural
	self assert: 'Sklaven' equals: word vocativePlural! !

!GermanMasculineNNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:17'!
testVocativeSingular
	self assert: 'Sklave' equals: word vocativeSingular ! !

TestCase subclass: #GermanMasculineNNounWithStemETest
	instanceVariableNames: 'word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin-Tests'!

!GermanMasculineNNounWithStemETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:49'!
setUp
	word := GermanMasculineNNoun withRoot: 'Herr'.! !

!GermanMasculineNNounWithStemETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:49'!
testAccusativePlural
	self assert: 'die Herren' equals: word accusativePlural ! !

!GermanMasculineNNounWithStemETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:49'!
testAccusativeSingular
	self assert: 'den Herrn' equals: word accusativeSingular ! !

!GermanMasculineNNounWithStemETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:49'!
testDativePlural
	self assert: 'den Herren' equals: word dativePlural! !

!GermanMasculineNNounWithStemETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:50'!
testDativeSingular
	self assert: 'dem Herrn' equals: word dativeSingular ! !

!GermanMasculineNNounWithStemETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:50'!
testNominativePlural
	self assert: 'die Herren' equals: word nominativePlural.! !

!GermanMasculineNNounWithStemETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:50'!
testNominativeSingular
	self assert: 'der Herr' equals: word nominativeSingular.! !

!GermanMasculineNNounWithStemETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:50'!
testVocativePlural
	self assert: 'Herren' equals: word vocativePlural! !

!GermanMasculineNNounWithStemETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:50'!
testVocativeSingular
	self assert: 'Herr' equals: word vocativeSingular ! !

TestCase subclass: #GermanMasculineNounTest
	instanceVariableNames: 'word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin-Tests'!

!GermanMasculineNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:04'!
setUp
	word := GermanMasculineENoun withRoot: 'Freund'.! !

!GermanMasculineNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:22'!
testAccusativePlural
	self assert: 'die Freunde' equals: word accusativePlural ! !

!GermanMasculineNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:22'!
testAccusativeSingular
	self assert: 'den Freund' equals: word accusativeSingular ! !

!GermanMasculineNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:22'!
testDativePlural
	self assert: 'den Freunden' equals: word dativePlural! !

!GermanMasculineNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:22'!
testDativeSingular
	self assert: 'dem Freund' equals: word dativeSingular ! !

!GermanMasculineNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:22'!
testNominativePlural
	self assert: 'die Freunde' equals: word nominativePlural.! !

!GermanMasculineNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:22'!
testNominativeSingular
	self assert: 'der Freund' equals: word nominativeSingular.! !

!GermanMasculineNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:23'!
testVocativePlural
	self assert: 'Freunde' equals: word vocativePlural! !

!GermanMasculineNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:23'!
testVocativeSingular
	self assert: 'Freund' equals: word vocativeSingular ! !

TestCase subclass: #GermanNeuterNounTest
	instanceVariableNames: 'word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin-Tests'!

!GermanNeuterNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 08:04'!
setUp
	word := GermanNeuterENoun withRoot: 'Pferd'.! !

!GermanNeuterNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:36'!
testAccusativePlural
	self assert: 'die Pferde' equals: word accusativePlural ! !

!GermanNeuterNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:37'!
testAccusativeSingular
	self assert: 'das Pferd' equals: word accusativeSingular ! !

!GermanNeuterNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:36'!
testDativePlural
	self assert: 'den Pferden' equals: word dativePlural! !

!GermanNeuterNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:36'!
testDativeSingular
	self assert: 'dem Pferd' equals: word dativeSingular ! !

!GermanNeuterNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:37'!
testNominativePlural
	self assert: 'die Pferde' equals: word nominativePlural.! !

!GermanNeuterNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:37'!
testNominativeSingular
	self assert: 'das Pferd' equals: word nominativeSingular.! !

!GermanNeuterNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:37'!
testVocativePlural
	self assert: 'Pferde' equals: word vocativePlural! !

!GermanNeuterNounTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 16:37'!
testVocativeSingular
	self assert: 'Pferd' equals: word vocativeSingular ! !

TestCase subclass: #GermanReflexiveVerbNoETest
	instanceVariableNames: 'word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin-Tests'!

!GermanReflexiveVerbNoETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 23:20'!
setUp 
	word := GermanReflexiveVerbNoE withRoot: 'nher'! !

!GermanReflexiveVerbNoETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 23:12'!
testFirstPersonPlural
	self assert: 'wir nhern uns' equals: word firstPersonPlural.! !

!GermanReflexiveVerbNoETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 23:12'!
testFirstPersonSingular
	self assert: 'ich nhere mich' equals: word firstPersonSingular.! !

!GermanReflexiveVerbNoETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 23:12'!
testImperativePlural
	self assert: 'nhert euch!!' equals: word imperativePlural.! !

!GermanReflexiveVerbNoETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 23:12'!
testImperativeSingular
	self assert: 'nhere dich!!' equals: word imperativeSingular.! !

!GermanReflexiveVerbNoETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 23:12'!
testInfinitive
	self assert: 'sich nhern' equals: word infinitive.! !

!GermanReflexiveVerbNoETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 23:12'!
testSecondPersonPlural
	self assert: 'ihr nhert euch' equals: word secondPersonPlural.! !

!GermanReflexiveVerbNoETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 23:12'!
testSecondPersonSingular
	self assert: 'du nherst dich' equals: word secondPersonSingular.! !

!GermanReflexiveVerbNoETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 23:12'!
testThirdPersonPlural
	self assert: 'sie nhern sich' equals: word thirdPersonPlural.! !

!GermanReflexiveVerbNoETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 23:13'!
testThirdPersonSingular
	self assert: 'er, sie, es nhert sich' equals: word thirdPersonSingular.! !

TestCase subclass: #GermanVerbGebenTest
	instanceVariableNames: 'word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin-Tests'!

!GermanVerbGebenTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 18:35'!
setUp 
	word := GermanVerbGeben new! !

!GermanVerbGebenTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 18:35'!
testFirstPersonPlural
	self assert: 'wir geben' equals: word firstPersonPlural.! !

!GermanVerbGebenTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 18:36'!
testFirstPersonSingular
	self assert: 'ich gebe' equals: word firstPersonSingular.! !

!GermanVerbGebenTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 18:36'!
testImperativePlural
	self assert: 'gebt!!' equals: word imperativePlural.! !

!GermanVerbGebenTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 18:36'!
testImperativeSingular
	self assert: 'gieb!!' equals: word imperativeSingular.! !

!GermanVerbGebenTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 18:36'!
testInfinitive
	self assert: 'geben' equals: word infinitive.! !

!GermanVerbGebenTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 18:36'!
testSecondPersonPlural
	self assert: 'ihr gebt' equals: word secondPersonPlural.! !

!GermanVerbGebenTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 18:36'!
testSecondPersonSingular
	self assert: 'du giebst' equals: word secondPersonSingular.! !

!GermanVerbGebenTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 18:36'!
testThirdPersonPlural
	self assert: 'sie geben' equals: word thirdPersonPlural.! !

!GermanVerbGebenTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 18:36'!
testThirdPersonSingular
	self assert: 'er, sie, es giebt' equals: word thirdPersonSingular.! !

TestCase subclass: #GermanVerbTest
	instanceVariableNames: 'word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin-Tests'!

!GermanVerbTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 12:43'!
setUp 
	word := GermanVerb withRoot: 'lieb'! !

!GermanVerbTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 12:45'!
testFirstPersonPlural
	self assert: 'wir lieben' equals: word firstPersonPlural.! !

!GermanVerbTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 12:45'!
testFirstPersonSingular
	self assert: 'ich liebe' equals: word firstPersonSingular.! !

!GermanVerbTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 12:45'!
testImperativePlural
	self assert: 'liebt!!' equals: word imperativePlural.! !

!GermanVerbTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 12:46'!
testImperativeSingular
	self assert: 'liebe!!' equals: word imperativeSingular.! !

!GermanVerbTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 12:46'!
testInfinitive
	self assert: 'lieben' equals: word infinitive.! !

!GermanVerbTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 12:46'!
testSecondPersonPlural
	self assert: 'ihr liebt' equals: word secondPersonPlural.! !

!GermanVerbTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 12:46'!
testSecondPersonSingular
	self assert: 'du liebst' equals: word secondPersonSingular.! !

!GermanVerbTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 12:46'!
testThirdPersonPlural
	self assert: 'sie lieben' equals: word thirdPersonPlural.! !

!GermanVerbTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 12:46'!
testThirdPersonSingular
	self assert: 'er, sie, es liebt' equals: word thirdPersonSingular.! !

TestCase subclass: #GermanVerbWithExtraETest
	instanceVariableNames: 'word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin-Tests'!

!GermanVerbWithExtraETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 17:04'!
setUp 
	word := GermanVerb withRoot: 'betracht'! !

!GermanVerbWithExtraETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 17:04'!
testFirstPersonPlural
	self assert: 'wir betrachten' equals: word firstPersonPlural.! !

!GermanVerbWithExtraETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 17:05'!
testFirstPersonSingular
	self assert: 'ich betrachte' equals: word firstPersonSingular.! !

!GermanVerbWithExtraETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 17:05'!
testImperativePlural
	self assert: 'betrachtet!!' equals: word imperativePlural.! !

!GermanVerbWithExtraETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 17:05'!
testImperativeSingular
	self assert: 'betrachte!!' equals: word imperativeSingular.! !

!GermanVerbWithExtraETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 17:05'!
testInfinitive
	self assert: 'betrachten' equals: word infinitive.! !

!GermanVerbWithExtraETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 17:05'!
testSecondPersonPlural
	self assert: 'ihr betrachtet' equals: word secondPersonPlural.! !

!GermanVerbWithExtraETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 17:05'!
testSecondPersonSingular
	self assert: 'du betrachtest' equals: word secondPersonSingular.! !

!GermanVerbWithExtraETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 17:05'!
testThirdPersonPlural
	self assert: 'sie betrachten' equals: word thirdPersonPlural.! !

!GermanVerbWithExtraETest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/6/2011 17:05'!
testThirdPersonSingular
	self assert: 'er, sie, es betrachtet' equals: word thirdPersonSingular.! !

TestCase subclass: #LatinNounADeclensionTest
	instanceVariableNames: 'word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin-Tests'!

!LatinNounADeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:36'!
setUp
	word := LatinNounADeclension withRoot: 'amic'.! !

!LatinNounADeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:36'!
testAccusativePlural
	self assert: 'amicas' equals: word accusativePlural ! !

!LatinNounADeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:36'!
testAccusativeSingular
	self assert: 'amicam' equals: word accusativeSingular ! !

!LatinNounADeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:35'!
testDativePlural
	self assert: 'amicis' equals: word dativePlural! !

!LatinNounADeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:36'!
testDativeSingular
	self assert: 'amicae' equals: word dativeSingular ! !

!LatinNounADeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:37'!
testNominativePlural
	self assert: 'amicae' equals: word nominativePlural.! !

!LatinNounADeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:37'!
testNominativeSingular
	self assert: 'amica' equals: word nominativeSingular.! !

!LatinNounADeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:37'!
testVocativePlural
	self assert: 'amicae' equals: word vocativePlural! !

!LatinNounADeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:37'!
testVocativeSingular
	self assert: 'amica' equals: word vocativeSingular ! !

TestCase subclass: #LatinNounODeclensionNeuterTest
	instanceVariableNames: 'word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin-Tests'!

!LatinNounODeclensionNeuterTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:38'!
setUp
	word := LatinNounODeclensionNeuter withRoot: 'don'.! !

!LatinNounODeclensionNeuterTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:38'!
testAccusativePlural
	self assert: 'dona' equals: word accusativePlural ! !

!LatinNounODeclensionNeuterTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:38'!
testAccusativeSingular
	self assert: 'donum' equals: word accusativeSingular ! !

!LatinNounODeclensionNeuterTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:38'!
testDativePlural
	self assert: 'donis' equals: word dativePlural! !

!LatinNounODeclensionNeuterTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:38'!
testDativeSingular
	self assert: 'dono' equals: word dativeSingular ! !

!LatinNounODeclensionNeuterTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:38'!
testNominativePlural
	self assert: 'dona' equals: word nominativePlural.! !

!LatinNounODeclensionNeuterTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:38'!
testNominativeSingular
	self assert: 'donum' equals: word nominativeSingular.! !

!LatinNounODeclensionNeuterTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:38'!
testVocativePlural
	self assert: 'dona' equals: word vocativePlural! !

!LatinNounODeclensionNeuterTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:39'!
testVocativeSingular
	self assert: 'donum' equals: word vocativeSingular ! !

TestCase subclass: #LatinNounODeclensionTest
	instanceVariableNames: 'word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin-Tests'!

!LatinNounODeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/2/2011 17:32'!
setUp
	word := LatinNounODeclension withRoot: 'amic'.! !

!LatinNounODeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:29'!
testAccusativePlural
	self assert: 'amicos' equals: word accusativePlural ! !

!LatinNounODeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:29'!
testAccusativeSingular
	self assert: 'amicum' equals: word accusativeSingular ! !

!LatinNounODeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:31'!
testDativePlural
	self assert: 'amicis' equals: word dativePlural! !

!LatinNounODeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:30'!
testDativeSingular
	self assert: 'amico' equals: word dativeSingular ! !

!LatinNounODeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/2/2011 17:41'!
testNominativePlural
	self assert: 'amici' equals: word nominativePlural.! !

!LatinNounODeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/2/2011 17:42'!
testNominativeSingular
	self assert: 'amicus' equals: word nominativeSingular.! !

!LatinNounODeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:30'!
testVocativePlural
	self assert: 'amici' equals: word vocativePlural! !

!LatinNounODeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:31'!
testVocativeSingular
	self assert: 'amice' equals: word vocativeSingular ! !

!LatinNounODeclensionTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 16:33'!
testVocativeSingularIStem
	self assert: 'Dari' equals: (LatinNounODeclension withRoot: 'Dari') vocativeSingular ! !

TestCase subclass: #LatinVerbAConjugationTest
	instanceVariableNames: 'word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin-Tests'!

!LatinVerbAConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:13'!
setUp
	word := LatinVerbAConjugation withRoot: 'voc'  ! !

!LatinVerbAConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:14'!
testFirstPersonPlural
	self assert: 'vocamus' equals: word firstPersonPlural.! !

!LatinVerbAConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:14'!
testFirstPersonSingular
	self assert: 'voco' equals: word firstPersonSingular.! !

!LatinVerbAConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:22'!
testImperativePlural
	self assert: 'vocate' equals: word imperativePlural.! !

!LatinVerbAConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:22'!
testImperativeSingular
	self assert: 'voca' equals: word imperativeSingular.! !

!LatinVerbAConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:21'!
testInfinitive
	self assert: 'vocare' equals: word infinitive.! !

!LatinVerbAConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:14'!
testSecondPersonPlural
	self assert: 'vocatis' equals: word secondPersonPlural.! !

!LatinVerbAConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:15'!
testSecondPersonSingular
	self assert: 'vocas' equals: word secondPersonSingular.! !

!LatinVerbAConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:16'!
testThirdPersonPlural
	self assert: 'vocant' equals: word thirdPersonPlural.! !

!LatinVerbAConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:15'!
testThirdPersonSingular
	self assert: 'vocat' equals: word thirdPersonSingular.! !

TestCase subclass: #LatinVerbEConjugationTest
	instanceVariableNames: 'word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin-Tests'!

!LatinVerbEConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:34'!
setUp
	word := LatinVerbEConjugation withRoot: 'par'  ! !

!LatinVerbEConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:31'!
testFirstPersonPlural
	self assert: 'paremus' equals: word firstPersonPlural.! !

!LatinVerbEConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:31'!
testFirstPersonSingular
	self assert: 'pareo' equals: word firstPersonSingular.! !

!LatinVerbEConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:31'!
testImperativePlural
	self assert: 'parete' equals: word imperativePlural.! !

!LatinVerbEConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:31'!
testImperativeSingular
	self assert: 'pare' equals: word imperativeSingular.! !

!LatinVerbEConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:31'!
testInfinitive
	self assert: 'parere' equals: word infinitive.! !

!LatinVerbEConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:31'!
testSecondPersonPlural
	self assert: 'paretis' equals: word secondPersonPlural.! !

!LatinVerbEConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:31'!
testSecondPersonSingular
	self assert: 'pares' equals: word secondPersonSingular.! !

!LatinVerbEConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:32'!
testThirdPersonPlural
	self assert: 'parent' equals: word thirdPersonPlural.! !

!LatinVerbEConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:32'!
testThirdPersonSingular
	self assert: 'paret' equals: word thirdPersonSingular.! !

TestCase subclass: #LatinVerbIConjugationTest
	instanceVariableNames: 'word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin-Tests'!

!LatinVerbIConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:34'!
setUp
	word := LatinVerbIConjugation withRoot: 'ven'  ! !

!LatinVerbIConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:32'!
testFirstPersonPlural
	self assert: 'venimus' equals: word firstPersonPlural.! !

!LatinVerbIConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:32'!
testFirstPersonSingular
	self assert: 'venio' equals: word firstPersonSingular.! !

!LatinVerbIConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:32'!
testImperativePlural
	self assert: 'venite' equals: word imperativePlural.! !

!LatinVerbIConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:32'!
testImperativeSingular
	self assert: 'veni' equals: word imperativeSingular.! !

!LatinVerbIConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:32'!
testInfinitive
	self assert: 'venire' equals: word infinitive.! !

!LatinVerbIConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:32'!
testSecondPersonPlural
	self assert: 'venitis' equals: word secondPersonPlural.! !

!LatinVerbIConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:33'!
testSecondPersonSingular
	self assert: 'venis' equals: word secondPersonSingular.! !

!LatinVerbIConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:33'!
testThirdPersonPlural
	self assert: 'veniunt' equals: word thirdPersonPlural.! !

!LatinVerbIConjugationTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/5/2011 18:33'!
testThirdPersonSingular
	self assert: 'venit' equals: word thirdPersonSingular.! !

TestCase subclass: #NoeFlexibleLessonTest
	instanceVariableNames: 'lesson'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Tests'!

!NoeFlexibleLessonTest methodsFor: 'running' stamp: 'MathiasKegelmann 3/6/2010 16:47'!
setUp 
	lesson := NoeFlexibleLesson newWithPlan: {
		NoeStubProblemGenerator .
		NoeStubProblemGenerator .
		NoeStubOneLevelProblemGenerator .
		NoeStubProblemGenerator}.
	lesson requiredCorrectAnswers: 2.! !

!NoeFlexibleLessonTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 16:22'!
testConstrucor
	self assert: true.! !

!NoeFlexibleLessonTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 22:49'!
testRunWithAllCorrectAnswers
	self 
		assert:   1 equals:  lesson nextProblem;
		assert:   2 equals: (lesson nextProblem: true);
		assert: 101 equals: (lesson nextProblem: true);
		assert: 102 equals: (lesson nextProblem: true);
		assert:   1 equals: (lesson nextProblem: true);
		assert:   2 equals: (lesson nextProblem: true);
		assert: 201 equals: (lesson nextProblem: true);
		assert: 202 equals: (lesson nextProblem: true);
		assert: nil equals: (lesson nextProblem: true).! !

!NoeFlexibleLessonTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 17:11'!
testRunWithCorrectAndWrongAnswers
	self 
		assert:   1 equals:  lesson nextProblem;
		assert:   1 equals: (lesson nextProblem: false);
		assert:   2 equals: (lesson nextProblem: true);
		assert:   2 equals: (lesson nextProblem: false);
		assert:   3 equals: (lesson nextProblem: true);
		assert: 101 equals: (lesson nextProblem: true);
		assert: 102 equals: (lesson nextProblem: true);
		assert: 102 equals: (lesson nextProblem: false);
		assert: 103 equals: (lesson nextProblem: true);
		assert:   1 equals: (lesson nextProblem: true);
		assert:   1 equals: (lesson nextProblem: false);
		assert:   2 equals: (lesson nextProblem: true);
		assert:   2 equals: (lesson nextProblem: false);
		assert:   3 equals: (lesson nextProblem: true);
		assert: 201 equals: (lesson nextProblem: true);
		assert: 202 equals: (lesson nextProblem: true);
		assert: nil equals: (lesson nextProblem: true).! !

TestCase subclass: #NoeLessonTest
	instanceVariableNames: 'problemGenerator lesson'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Tests'!

!NoeLessonTest methodsFor: 'running' stamp: 'MathiasKegelmann 3/6/2010 15:02'!
setUp 
	problemGenerator := NoeStubProblemGenerator new.
	lesson := NoeLesson newWithProblemGenerator: problemGenerator.
	lesson requiredCorrectAnswers: 3.! !

!NoeLessonTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 14:55'!
testInitiallyTheLastProblemIsNil
	self assert: nil equals: (lesson nextProblem: false).! !

!NoeLessonTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 15:06'!
testNextLevelAfterThreeCorrectAnswers
	2 timesRepeat: [lesson nextProblem: true].
	self assert: 101 equals: (lesson nextProblem: true).! !

!NoeLessonTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 15:07'!
testNextLevelAfterWrongAnswers
	2 timesRepeat: [lesson nextProblem: true].
	lesson nextProblem: false.
	2 timesRepeat: [lesson nextProblem: true].
	self assert: 101 equals: (lesson nextProblem: true).! !

!NoeLessonTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 14:09'!
testNextProblem
	self assert: 1 equals: lesson nextProblem.! !

!NoeLessonTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 14:59'!
testNextProblemForCorrectAnswer
	self assert: 1 equals: (lesson nextProblem: true).! !

!NoeLessonTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 15:01'!
testNextProblemForTwoCorrectAnswers
	lesson nextProblem: true.
	self assert: 2 equals: (lesson nextProblem: true).! !

!NoeLessonTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 15:00'!
testNextProblemForWrongAnswer
	lesson nextProblem: true.
	self assert: 1 equals: (lesson nextProblem: false).! !

!NoeLessonTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 15:07'!
testThirdLevelAfterSixCorrectAnswers
	5 timesRepeat: [lesson nextProblem: true].
	self assert: 201 equals: (lesson nextProblem: true).! !

TestCase subclass: #NoeLessonWithoutGeneratorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Tests'!

!NoeLessonWithoutGeneratorTest methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 3/6/2010 15:57'!
testProblemReturnsNil
	|lesson|
	lesson := NoeLesson newWithProblemGenerator: nil.
	self assert: nil equals: lesson nextProblem. ! !

TestCase subclass: #NoeLessonWithoutLevelTwoTest
	instanceVariableNames: 'problemGenerator lesson'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Tests'!

!NoeLessonWithoutLevelTwoTest methodsFor: 'running' stamp: 'MathiasKegelmann 3/6/2010 16:02'!
setUp 
	problemGenerator := NoeStubOneLevelProblemGenerator new.
	lesson := NoeLesson newWithProblemGenerator: problemGenerator.
	lesson requiredCorrectAnswers: 2.! !

!NoeLessonWithoutLevelTwoTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 16:02'!
testNextProblemForCorrectAnswer
	self assert: 1 equals: (lesson nextProblem: true).! !

!NoeLessonWithoutLevelTwoTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 16:05'!
testNextProblemForRightWrong
	lesson nextProblem: true.
	self assert: 1 equals: (lesson nextProblem: false).! !

!NoeLessonWithoutLevelTwoTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 16:09'!
testNextProblemForRightWrongRight
	lesson nextProblem: true.
	lesson nextProblem: false.
	self assert: 2 equals: (lesson nextProblem: true).! !

!NoeLessonWithoutLevelTwoTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 16:11'!
testNextProblemForRightWrongRightRight
	lesson nextProblem: true.
	lesson nextProblem: false.
	lesson nextProblem: true.
	self assert: nil equals: (lesson nextProblem: true).! !

!NoeLessonWithoutLevelTwoTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 16:10'!
testNextProblemForTwoCorrectAnswers
	lesson nextProblem: true.
	self assert: nil equals: (lesson nextProblem: true).! !

TestCase subclass: #NoeProblemTest
	instanceVariableNames: 'problem correctAnswer wrongAnswer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Tests'!

!NoeProblemTest methodsFor: 'running' stamp: 'MathiasKegelmann 3/6/2010 22:04'!
setUp
	correctAnswer := 2.
	wrongAnswer := correctAnswer + 1.
	problem := NoeProblem text: 'dummy' options: #(1 2 3) answer: correctAnswer.! !

!NoeProblemTest methodsFor: 'tests' stamp: 'MathiasKegelmann 2/20/2010 22:15'!
testCorrectAnswer
	self assert: (problem isCorrectAnswer: correctAnswer).! !

!NoeProblemTest methodsFor: 'tests' stamp: 'MathiasKegelmann 2/20/2010 22:17'!
testWrongAnswer
	self deny: (problem isCorrectAnswer: wrongAnswer).! !

TestCase subclass: #NonDuplicateRandomSequenceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Tests'!

!NonDuplicateRandomSequenceTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 09:19'!
testFirstNNumbersAreAPermutation
	|numbers n sequence|
	n := 5.
	numbers := Bag new.
	sequence := NonDuplicateRandomSequence new: n.
	n timesRepeat: [ numbers add: sequence next].
	self assert: (numbers sameElements: (1 to: n)).! !

TestCase subclass: #SimpleTenComplementProblemGeneratorTest
	instanceVariableNames: 'generator problem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Maths-Tests'!

!SimpleTenComplementProblemGeneratorTest methodsFor: 'running' stamp: 'MathiasKegelmann 2/20/2010 22:45'!
setUp
	generator := ComplementProblemGenerator new.
	problem := generator generateProblem.! !

!SimpleTenComplementProblemGeneratorTest methodsFor: 'tests' stamp: 'MathiasKegelmann 2/20/2010 23:17'!
testOptions	
	self assert: #(1 2 3 4 5 6 7 8 9) equals: problem options.! !

!SimpleTenComplementProblemGeneratorTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 22:02'!
testProblemSemantics
      | question answer |
	question := ((problem text substrings) at: 4) asInteger.
	answer := 10 - question.
	self assert: (problem isCorrectAnswer: answer).! !

!SimpleTenComplementProblemGeneratorTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 22:02'!
testProblemText
	self assert: ('Was fehlt von * bis 10?' match: problem text).! !

TestCase subclass: #SquareProblemGeneratorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Maths-Tests'!

!SquareProblemGeneratorTest methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 22:02'!
testProblem
   | problem question answer |
	problem := SquareProblemGenerator basicNew initialize: (NoeNonRandomSequence new); generateProblem.
	self assert: 'Was ist 5 mal 5?' equals: problem text.
	self assert: #(1 4 9 16 25 36 49 64 81 100) equals: problem options asArray.
	self assert: (problem isCorrectAnswer: 25).! !

Object subclass: #AbstractInflectedWord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!AbstractInflectedWord methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 21:21'!
inflect
	"Convert the stored word and form to an inflected word as a string"
	self subclassResponsibility ! !

!AbstractInflectedWord methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 22:04'!
options
	self subclassResponsibility ! !

AbstractInflectedWord subclass: #FixedInflectedWord
	instanceVariableNames: 'word'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!FixedInflectedWord classSide methodsFor: 'instance creation' stamp: 'MathiasKegelmann 11/6/2011 21:00'!
word: aString
	^ self basicNew word: aString! !

!FixedInflectedWord methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 21:11'!
inflect
	^ word! !

!FixedInflectedWord methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 22:05'!
options
	^ {self inflect}! !

!FixedInflectedWord methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/6/2011 21:00'!
word: aString
	word := aString! !

AbstractInflectedWord subclass: #InflectedWord
	instanceVariableNames: 'word form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!InflectedWord classSide methodsFor: 'instance creation' stamp: 'MathiasKegelmann 11/6/2011 21:23'!
word: aString form: aForm
	^ self basicNew word: aString form: aForm ! !

!InflectedWord methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 21:22'!
inflect
	^ form of: word! !

!InflectedWord methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 22:22'!
options
	|correct alternatives options|
	correct := self inflect.
	alternatives := ((form allFormsOf: word) select: [:w | w ~= correct]) asArray shuffled.
	alternatives ifEmpty: [options := {correct}] 
		ifNotEmpty: [options := {correct . alternatives first}].
	^ options shuffled! !

!InflectedWord methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/6/2011 21:23'!
word: aString form: aForm 
	word := aString.
	form := aForm! !

Object subclass: #AbstractProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables'!

!AbstractProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/12/2010 07:23'!
hardness
	"the factor to multiply the basic time by"
	^ 1.! !

!AbstractProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/12/2010 07:17'!
nextLevel
	^ nil.! !

!AbstractProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/12/2010 07:21'!
options: options forAnswer: answer
	^ ((options asArray shuffled copyFrom: 1 to: 14) union: {answer}) asArray shuffled asSortedCollection! !

!AbstractProblemGenerator methodsFor: 'helper' stamp: 'MathiasKegelmann 11/5/2011 14:22'!
randomBoolean
	^ 2 atRandom = 1.! !

AbstractProblemGenerator subclass: #AbstractSentenceProblemGenerator
	instanceVariableNames: 'sentenceStart sentenceEnd german directObjects subjects indirectObjects latinVerb germanVerb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

AbstractSentenceProblemGenerator subclass: #AbstractSOOVSentenceProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!AbstractSOOVSentenceProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 11/13/2011 18:08'!
generateProblem 
	| word case |
	self startBuilding addSubjectAndPredicate addIndirectObject addDirectObject.
	^ NoeProblem 
		text: 'bersetzte folgenden Satz ins Lateinische: ', String cr, self german
		options: self latinOptions
		answer: self latin.! !

!AbstractSOOVSentenceProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 18:30'!
hardness 
	^3! !

AbstractSOOVSentenceProblemGenerator subclass: #GiveSentenceProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!GiveSentenceProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/7/2011 18:39'!
initialize 
	germanVerb := GermanVerbGeben new.
	latinVerb := LatinVerbAConjugation withRoot: 'd'.

	directObjects := {
		(GermanNeuterENoun withRoot: 'Geschenk') -> (LatinNounODeclensionNeuter withRoot: 'don' ) .
    }.
	
	indirectObjects := {
		(GermanMasculineENoun withRoot: 'Freund') -> (LatinNounODeclension withRoot: 'amic') .
		(GermanFeminineNoun withRoot: 'Freundin') -> (LatinNounADeclension withRoot: 'amic') .
		(GermanMasculineFixedNoun withRoot: 'Rmer') -> (LatinNounODeclension withRoot: 'Roman') .
		(GermanFeminineNoun withRoot: 'Rmerin') -> (LatinNounADeclension withRoot: 'Roman') .
	}.
	
	subjects := {
		(GermanMasculineNNoun withRoot: 'Herr') -> (LatinNounODeclension withRoot: 'domin') .
		(GermanFeminineNoun withRoot: 'Herrin') -> (LatinNounADeclension withRoot: 'domin') .		
	}.

	
	! !

AbstractSentenceProblemGenerator subclass: #AbstractSOaVSentenceProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!AbstractSOaVSentenceProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 11/6/2011 22:27'!
generateProblem 
	| word case |
	self startBuilding addSubjectAndPredicate addDirectObject.
	^ NoeProblem 
		text: 'bersetzte folgenden Satz ins Lateinische: ', String cr, self german
		options: self latinOptions
		answer: self latin.! !

!AbstractSOaVSentenceProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 18:29'!
hardness 
	^2.5! !

AbstractSOaVSentenceProblemGenerator subclass: #CallSentenceProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!CallSentenceProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/7/2011 12:44'!
initialize 
	germanVerb := GermanVerb withRoot: 'ruf'.
	latinVerb := LatinVerbAConjugation withRoot: 'voc'.

	directObjects := {
		(GermanNeuterENoun withRoot: 'Pferd') -> (LatinNounODeclension withRoot: 'equ') .
		(GermanMasculineNNoun withRoot: 'Sklave') -> (LatinNounODeclension withRoot: 'serv') .
		(GermanMasculineENoun withRoot: 'Freund') -> (LatinNounODeclension withRoot: 'amic') .
		(GermanFeminineNoun withRoot: 'Freundin') -> (LatinNounADeclension withRoot: 'amic') .
		(GermanFeminineNoun withRoot: 'Sklavin') -> (LatinNounADeclension withRoot: 'serv') .
	}.
	
	subjects := {
		(GermanMasculineENoun withRoot: 'Freund') -> (LatinNounODeclension withRoot: 'amic') .
		(GermanMasculineNNoun withRoot: 'Herr') -> (LatinNounODeclension withRoot: 'domin') .
		(GermanMasculineFixedNoun withRoot: 'Rmer') -> (LatinNounODeclension withRoot: 'Roman') .
		(GermanFeminineNoun withRoot: 'Rmerin') -> (LatinNounADeclension withRoot: 'Roman') .
	}.

	
	! !

AbstractSOaVSentenceProblemGenerator subclass: #ObserveSentenceProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!ObserveSentenceProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/7/2011 08:04'!
initialize 
	germanVerb := GermanVerb withRoot: 'betracht'.
	latinVerb := LatinVerbAConjugation withRoot: 'spect'.
	
	directObjects := {
		(GermanNeuterENoun withRoot: 'Pferd') -> (LatinNounODeclension withRoot: 'equ') .

		(GermanNeuterENoun withRoot: 'Tor') -> (LatinNounADeclension withRoot: 'port') .

		(GermanFeminineNoun withRoot: 'Spur') -> (LatinNounODeclensionNeuter withRoot: 'vestigi') .
		(GermanNeuterENoun withRoot: 'Geschenk') -> (LatinNounODeclensionNeuter withRoot: 'don') .
		(GermanFeminineNoun withRoot: 'Wohnung') -> (LatinNounODeclensionNeuter withRoot: 'domicili')
	}.
	
	subjects := {
		(GermanMasculineENoun withRoot: 'Freund') -> (LatinNounODeclension withRoot: 'amic') .
		(GermanFeminineNoun withRoot: 'Freundin') -> (LatinNounADeclension withRoot: 'amic') .
		(GermanFeminineNoun withRoot: 'Rmerin') -> (LatinNounADeclension withRoot: 'Roman') .
	}.

	
	! !

AbstractSentenceProblemGenerator subclass: #AbstractSOdVSentenceProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!AbstractSOdVSentenceProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 11/6/2011 23:04'!
generateProblem 
	| word case |
	self startBuilding addSubjectAndPredicate addIndirectObject.
	^ NoeProblem 
		text: 'bersetzte folgenden Satz ins Lateinische: ', String cr, self german
		options: self latinOptions
		answer: self latin.! !

!AbstractSOdVSentenceProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 18:28'!
hardness 
	^2.5! !

AbstractSOdVSentenceProblemGenerator subclass: #ApproachSentenceProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!ApproachSentenceProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/7/2011 08:04'!
initialize 
	germanVerb := GermanReflexiveVerbNoE withRoot: 'nher'.
	latinVerb := LatinVerbAConjugation withRoot: 'appropinqu'.
	

	indirectObjects := {
		(GermanFeminineNoun withRoot: 'Wohnung') -> (LatinNounODeclensionNeuter withRoot: 'domicili') .
		(GermanFeminineNoun withRoot: 'Rmerin') -> (LatinNounADeclension withRoot: 'Roman') .
		(GermanNeuterENoun withRoot: 'Monument' ) -> (LatinNounODeclensionNeuter withRoot: 'monument') .
	}.
	
	subjects := {
		(GermanMasculineENoun withRoot: 'Freund') -> (LatinNounODeclension withRoot: 'amic') .
		(GermanFeminineNoun withRoot: 'Freundin') -> (LatinNounADeclension withRoot: 'amic') .
		(GermanNeuterENoun withRoot: 'Pferd') -> (LatinNounODeclension withRoot: 'equ')
	}.

	
	! !

AbstractSOdVSentenceProblemGenerator subclass: #ObeySentenceProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!ObeySentenceProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/7/2011 18:14'!
initialize 
	germanVerb := GermanVerb withRoot: 'gehorch'.
	latinVerb := LatinVerbEConjugation withRoot: 'par'.
	
	indirectObjects := {
		(GermanMasculineENoun withRoot: 'Freund') -> (LatinNounODeclension withRoot: 'amic') .
		(GermanMasculineNNoun withRoot: 'Herr') -> (LatinNounODeclension withRoot: 'domin') .
		(GermanFeminineNoun withRoot: 'Herrin') -> (LatinNounADeclension withRoot: 'domin') .
		(GermanMasculineFixedNoun withRoot: 'Rmer') -> (LatinNounODeclension withRoot: 'Roman') .
		(GermanFeminineNoun withRoot: 'Rmerin') -> (LatinNounADeclension withRoot: 'Roman')
	}.
	
	subjects := {
		(GermanMasculineNNoun withRoot: 'Sklave') -> (LatinNounODeclension withRoot: 'serv') .
		(GermanFeminineNoun withRoot: 'Sklavin') -> (LatinNounADeclension withRoot: 'serv') .
		(GermanNeuterENoun withRoot: 'Pferd') -> (LatinNounODeclension withRoot: 'equ') .
	}.

	
	! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 23:00'!
addDirectObject
	|germanLatin case|
	germanLatin := self randomDirectObject.
	case := self randomBoolean ifTrue: [AccusativeSingular] ifFalse: [AccusativePlural].
	sentenceStart add: (InflectedWord  word: germanLatin value form: case).
	german := german, ' ', (case of: germanLatin key)! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 23:02'!
addIndirectObject
	|germanLatin case|
	germanLatin := self randomIndirectObject.
	case := self randomBoolean ifTrue: [DativeSingular] ifFalse: [DativePlural].
	sentenceStart add: (InflectedWord  word: germanLatin value form: case).
	german := german, ' ', (case of: germanLatin key)! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 22:55'!
addNonThirdPersonSubjectAndPredicate: aCase
	sentenceEnd add: (InflectedWord  word: self latinVerb form: aCase).
	german := (aCase of: self germanVerb) capitalized! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 22:55'!
addNounSubjectAndPredicate
	|subject|
	subject := self randomSubject.
	german := (NominativeSingular of: subject key) capitalized, ' ', self germanThirdPersonVerb.
	sentenceStart add: (InflectedWord word: subject value form: NominativeSingular).
	sentenceEnd add: (InflectedWord word: self latinVerb form: ThirdPersonSingular)! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 22:55'!
addNounsSubjectAndPredicate
	|subject|
	subject := self randomSubject.
	german := (NominativePlural of: subject key) capitalized, ' ', self germanThirdPersonPluralVerb.
	sentenceStart add: (InflectedWord word: subject value form: NominativePlural).
	sentenceEnd add: (InflectedWord word: self latinVerb form: ThirdPersonPlural)! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 22:55'!
addPeopleSubjectAndPredicate
	german := 'Dacus und Flavia ', self germanThirdPersonPluralVerb.
	sentenceStart add: (FixedInflectedWord word: 'Dacus et Flavia').
	sentenceEnd add: (InflectedWord word: self latinVerb form: ThirdPersonPlural)
	! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 22:55'!
addPersonSubjectAndPredicate
	|person|
	person := self randomPerson.
	german := person, ' ', self germanThirdPersonVerb.
	sentenceStart add: (FixedInflectedWord word: person).
	sentenceEnd add: (InflectedWord word: self latinVerb form: ThirdPersonSingular)
	! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 22:55'!
addSubjectAndPredicate
	| person |
	person := VerbPerson normalPersonAtRandom.
	person = ThirdPersonSingular ifTrue:  [^ self addThirdPersonSingularSubjectAndPredicate].
	person = ThirdPersonPlural ifTrue:  [^ self addThirdPersonPluralSubjectAndPredicate].
	self addNonThirdPersonSubjectAndPredicate: person.
! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 22:56'!
addThirdPersonPluralSubjectAndPredicate
	|choice|
	choice := 3 atRandom.
	choice = 1 ifTrue: [^ self addNonThirdPersonSubjectAndPredicate: ThirdPersonPlural].
	choice = 2 ifTrue: [^ self addPeopleSubjectAndPredicate].
	self  addNounsSubjectAndPredicate! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 22:56'!
addThirdPersonSingularSubjectAndPredicate
	self randomBoolean 
		ifTrue: [self addPersonSubjectAndPredicate] 
		ifFalse: [self addNounSubjectAndPredicate] ! !

!AbstractSentenceProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 11/6/2011 22:54'!
generateProblem
	self subclassResponsibility! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 22:56'!
german
	^ german! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 23:34'!
germanThirdPersonPluralVerb
	| words |
	words := ' ' split: (ThirdPersonPlural of: self germanVerb).
	words last = 'sich' ifTrue: [^ ' ' join: (words last: 2)] ifFalse:  [^ words last]
! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 23:34'!
germanThirdPersonVerb
| words |
	words := ' ' split: (ThirdPersonSingular of: self germanVerb).
	words last = 'sich' ifTrue: [^ ' ' join: (words last: 2)] ifFalse:  [^ words last]
! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/7/2011 07:53'!
germanVerb
	^germanVerb! !

!AbstractSentenceProblemGenerator methodsFor: 'test private' stamp: 'MathiasKegelmann 11/7/2011 07:59'!
germanVerb: anObject
	germanVerb := anObject! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 22:57'!
latin
	^ ' ' join: ((sentenceStart, sentenceEnd) collect: [:word | word inflect])! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 22:57'!
latinOptions
	|options|
	options := ((sentenceStart, sentenceEnd) collect: [:word | word options]) cartesianProduct.
	^ options collect: [:words | ' ' join: words]! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/7/2011 07:52'!
latinVerb
	^ latinVerb! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 23:00'!
randomDirectObject
	^ directObjects atRandom! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 23:01'!
randomIndirectObject
	^ indirectObjects atRandom! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 22:57'!
randomPerson
	^ { 'Rufus' . 'Dacus' . 'Aurelia' . 'Flavia'} atRandom! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 22:57'!
randomSubject
	^ subjects atRandom! !

!AbstractSentenceProblemGenerator methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 22:58'!
startBuilding
	sentenceStart := OrderedCollection new.
	sentenceEnd :=  OrderedCollection new.
	! !

AbstractProblemGenerator subclass: #CombinedProblemGenerator
	instanceVariableNames: 'problemGenerators'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables'!

CombinedProblemGenerator subclass: #BasicVerbNounAnalysisProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!BasicVerbNounAnalysisProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/12/2011 17:09'!
hardness 
	^ 2.5! !

!BasicVerbNounAnalysisProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/12/2011 17:08'!
problemGenerators
	^{ DeclensionAnalysisProblemGenerator . ConjugationAnalysisProblemGenerator }! !

CombinedProblemGenerator subclass: #CombinedAgeProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Maths'!

!CombinedAgeProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/20/2010 23:17'!
hardness 
	^ 4.! !

!CombinedAgeProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/6/2011 14:29'!
problemGenerators
	^{AgeProblemGenerator . AgeReverseProblemGenerator}! !

!CombinedProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 11/6/2011 14:29'!
generateProblem
	^ problemGenerators atRandom generateProblem.! !

!CombinedProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/6/2011 14:28'!
initialize 
	problemGenerators := self problemGenerators collect: [:generatorClass | generatorClass new].  ! !

!CombinedProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/6/2011 14:28'!
problemGenerators
	self subclassResponsibility ! !

CombinedProblemGenerator subclass: #CombinedSOOVProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!CombinedSOOVProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 18:42'!
hardness 
	^3.5! !

!CombinedSOOVProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/7/2011 18:42'!
problemGenerators
	^{ CombinedSOaVProblemGenerator .  CombinedSOdVProblemGenerator . GiveSentenceProblemGenerator }! !

CombinedProblemGenerator subclass: #CombinedSOVProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!CombinedSOVProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 18:29'!
hardness 
	^2.5! !

!CombinedSOVProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/6/2011 23:29'!
problemGenerators
	^{ CombinedSOaVProblemGenerator .  CombinedSOdVProblemGenerator }! !

CombinedProblemGenerator subclass: #CombinedSOaVProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!CombinedSOaVProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 18:29'!
hardness 
	^2.5! !

!CombinedSOaVProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/6/2011 22:36'!
problemGenerators
	^{ CallSentenceProblemGenerator . ObserveSentenceProblemGenerator }! !

CombinedProblemGenerator subclass: #CombinedSOdVProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!CombinedSOdVProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 18:30'!
hardness 
	^2.5! !

!CombinedSOdVProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/6/2011 23:28'!
problemGenerators
	^{ ObeySentenceProblemGenerator . ApproachSentenceProblemGenerator }! !

AbstractProblemGenerator subclass: #ComplementProblemGenerator
	instanceVariableNames: 'base complement randomSequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Maths'!

ComplementProblemGenerator subclass: #BigComplementProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Maths'!

!BigComplementProblemGenerator methodsFor: 'configuration' stamp: 'MathiasKegelmann 3/6/2010 22:14'!
complement 
	self subclassResponsibility.! !

!BigComplementProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/6/2010 22:13'!
createRandomSequence
	^ NonDuplicateRandomSequence new: self complement - 1.! !

!BigComplementProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/12/2010 07:24'!
hardness
	^ 1.5! !

!BigComplementProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/6/2010 22:13'!
initialize
	self initializeWithBase: 0 andComplement: self complement.! !

!BigComplementProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/6/2010 22:13'!
nextLevel
	^ nil.! !

!BigComplementProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/12/2010 07:20'!
optionsForAnswer: answer
	| options |
	options := 1 to: self complement - 1.
	^ self options: options forAnswer: answer! !

BigComplementProblemGenerator subclass: #ComplementOneHundredProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Maths'!

!ComplementOneHundredProblemGenerator methodsFor: 'configuration' stamp: 'MathiasKegelmann 3/6/2010 22:11'!
complement 
	^ 100.! !

BigComplementProblemGenerator subclass: #ComplementOneThousandProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Maths'!

!ComplementOneThousandProblemGenerator methodsFor: 'configuration' stamp: 'MathiasKegelmann 3/6/2010 22:15'!
complement
	^ 1000.! !

!ComplementProblemGenerator classSide methodsFor: 'instance creation' stamp: 'MathiasKegelmann 2/26/2010 23:35'!
withBase: aBase andComplement: aComplement
	| complementProblemGenerator |
	complementProblemGenerator := self basicNew.
	complementProblemGenerator initializeWithBase: aBase andComplement: aComplement.
	^ complementProblemGenerator.! !

!ComplementProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/6/2010 17:56'!
createRandomSequence
	^ NonDuplicateRandomSequence new: 9! !

!ComplementProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/6/2010 22:04'!
generateProblem
	| question answer |
	question := randomSequence next + base.
	answer := complement - question.
	^ NoeProblem
		text:
			('Was fehlt von {1} bis {2}?'
				format:
					{question asString.
					complement})
		options: (self optionsForAnswer: answer)
		answer: answer.! !

!ComplementProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/12/2010 07:24'!
hardness 
	^ 0.7! !

!ComplementProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 2/26/2010 23:37'!
initialize
	self initializeWithBase: 0 andComplement: 10.! !

!ComplementProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/6/2010 17:56'!
initializeWithBase: aBase andComplement: aComplement
	super initialize.
	base := aBase.
	complement := aComplement.
	randomSequence := self createRandomSequence! !

!ComplementProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 2/26/2010 23:42'!
nextLevel
	^ self class withBase: base + 10 andComplement: complement + 10.! !

!ComplementProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/6/2010 17:56'!
optionsForAnswer: answer
	^ #(1 2 3 4 5 6 7 8 9)! !

AbstractProblemGenerator subclass: #ConjugationAnalysisProblemGenerator
	instanceVariableNames: 'words'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!ConjugationAnalysisProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 11/12/2011 17:07'!
generateProblem 
	| word person dict conjugatedVerb |
	word := words atRandom.
	person := VerbPerson atRandom.
	conjugatedVerb := person of: word.
		
	dict := Dictionary new.
	(VerbPerson allFormWordPairsOf: word) do: [:pair | dict at: pair second put: pair first].
	dict at: conjugatedVerb put: person.
	
	^ NoeProblem 
		text: ('Bestimme die Form von {1}:' format: {conjugatedVerb})
		options: (dict values collect: [:c | c displayName]) shuffled   
		answer: person displayName
! !

!ConjugationAnalysisProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/12/2011 17:07'!
hardness 
	^ 2.5! !

!ConjugationAnalysisProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/12/2011 17:04'!
initialize
	super initialize.
	words :={
		LatinVerbAConjugation withRoot: 'am' .
		LatinVerbAConjugation withRoot: 'voc' .
		LatinVerbEConjugation withRoot: 'par' . 
		LatinVerbEConjugation withRoot: 'mon' .
		LatinVerbIConjugation withRoot: 'ven' .  
		LatinVerbIConjugation withRoot: 'aud'
	}! !

AbstractProblemGenerator subclass: #ConjugationProblemGenerator
	instanceVariableNames: 'words'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!ConjugationProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 11/6/2011 22:16'!
generateProblem 
	| word person |
	word := words atRandom.
	person := VerbPerson atRandom.
	^ NoeProblem 
		text: ('Bilde den ''{1}'' von ''{2}'':' format: {person displayName . word infinitive})
		options: (VerbPerson allFormsOf: word) asArray shuffled   
		answer: (person of:  word)! !

!ConjugationProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 19:38'!
hardness 
	^ 2! !

!ConjugationProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/5/2011 20:22'!
initialize
	super initialize.
	words :={
		LatinVerbAConjugation withRoot: 'am' .
		LatinVerbAConjugation withRoot: 'voc' .
		LatinVerbEConjugation withRoot: 'par' . 
		LatinVerbEConjugation withRoot: 'mon' .
		LatinVerbIConjugation withRoot: 'ven' .  
		LatinVerbIConjugation withRoot: 'aud'
	}! !

AbstractProblemGenerator subclass: #DeclensionAnalysisProblemGenerator
	instanceVariableNames: 'words'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!DeclensionAnalysisProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 11/12/2011 17:02'!
generateProblem 
	| word case dict declinedWord |
	word := words atRandom.
	case := NounCase atRandom.
	declinedWord := case of: word.
	
	dict := Dictionary new.
	(NounCase allFormWordPairsOf: word) do: [:pair | dict at: pair second put: pair first].
	dict at: declinedWord put: case.
	
	^ NoeProblem 
		text: ('Bestimme den Fall von {1}:' format: {declinedWord})
		options: (dict values collect: [:c | c displayName]) shuffled   
		answer: case displayName! !

!DeclensionAnalysisProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/12/2011 17:07'!
hardness 
	^ 2.5! !

!DeclensionAnalysisProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/12/2011 16:41'!
initialize
	super initialize.
	words :={
		LatinNounODeclension withRoot: 'equ'.   
		LatinNounODeclension withRoot: 'amic'.   
		LatinNounODeclension withRoot: 'Tiberi' .   
		LatinNounADeclension withRoot: 'Flavi' .   
		LatinNounADeclension withRoot: 'domin'.
		LatinNounODeclensionNeuter withRoot: 'don' .   
		LatinNounODeclensionNeuter withRoot: 'domicili'
	}! !

AbstractProblemGenerator subclass: #DeclensionProblemGenerator
	instanceVariableNames: 'words'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!DeclensionProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 11/6/2011 22:16'!
generateProblem 
	| word case |
	word := words atRandom.
	case := NounCase atRandom.
	^ NoeProblem 
		text: ('Bilde den ''{1}'' von ''{2}'':' format: {case displayName . word nominativeSingular})
		options: (NounCase allFormsOf: word) asArray shuffled   
		answer: (case of:  word)! !

!DeclensionProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 18:00'!
hardness 
	^ 2! !

!DeclensionProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/5/2011 18:03'!
initialize
	super initialize.
	words :={
		LatinNounODeclension withRoot: 'equ'.   
		LatinNounODeclension withRoot: 'amic'.   
		LatinNounODeclension withRoot: 'Tiberi' .   
		LatinNounADeclension withRoot: 'Flavi' .   
		LatinNounADeclension withRoot: 'domin'.
		LatinNounODeclensionNeuter withRoot: 'don' .   
		LatinNounODeclensionNeuter withRoot: 'domicili'
	}! !

AbstractProblemGenerator subclass: #DictionaryProblemGenerator
	instanceVariableNames: 'questions questionKeysToAsk'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables'!

DictionaryProblemGenerator class
	instanceVariableNames: 'questions'!

DictionaryProblemGenerator class
	instanceVariableNames: 'questions'!

DictionaryProblemGenerator subclass: #BidirectionalDictionaryProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!BidirectionalDictionaryProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 11/6/2011 13:20'!
backwardTemplate 
	^ '{1}'! !

!BidirectionalDictionaryProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 11/6/2011 13:20'!
forwardTemplate 
	^ '{1}'! !

!BidirectionalDictionaryProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 11/6/2011 13:19'!
generateProblem
	| assoc |
	assoc := self nextQuestionAnswerAssociation.
	self randomBoolean
		ifTrue: [^ NoeProblem
					text: (self backwardTemplate format: {assoc value})
					options: questions keys asArray shuffled
					answer: assoc key.]	
		ifFalse: [^ NoeProblem
					text: (self forwardTemplate format: {assoc key})
					options: questions values asArray shuffled
					answer: assoc value]! !

BidirectionalDictionaryProblemGenerator subclass: #CasesDictionaryProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!CasesDictionaryProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/6/2011 13:26'!
backwardTemplate 
	^ 'Nach welchem Fall fragt man mit', String cr, '''{1}'''
! !

!CasesDictionaryProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/6/2011 13:22'!
forwardTemplate 
	^ 'Wie fragt man nach dem {1}?'
! !

!CasesDictionaryProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/5/2011 16:10'!
questions
	^ Dictionary
		newFrom:
			{'Nominativ' -> 'Wer oder was?'.
			 'Akkusativ' -> 'Wen oder was?'.
			 'Dativ' -> 'Wem?'.
			 'Vokativ' -> 'Wer wird gerufen?'
			}! !

BidirectionalDictionaryProblemGenerator subclass: #ConjugationDictionaryProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!ConjugationDictionaryProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/6/2011 13:54'!
backwardTemplate 
	^ 'Bei welcher Form steht im Deutschen', String cr, '''{1}''?'
! !

!ConjugationDictionaryProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/6/2011 13:57'!
forwardTemplate 
	^ 'Welches Wort steht im Deutschen bei der Form', String cr, ' {1}?'
! !

!ConjugationDictionaryProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/5/2011 19:37'!
hardness 
	^ 2! !

!ConjugationDictionaryProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/6/2011 13:33'!
questions
	^ Dictionary
		newFrom: {
			'1. Person Singular' -> 'ich'.
	 		'2. Person Singular' -> 'du'.
			'3. Person Singular' -> 'er, sie, es'.
			'1. Person Plural' -> 'wir'.
	 		'2. Person Plural' -> 'ihr'.
			'3. Person Plural' -> 'sie'.
			'Infinitiv' -> 'zu, um zu'	
			}! !

!DictionaryProblemGenerator methodsFor: 'helper' stamp: 'MathiasKegelmann 11/5/2011 14:38'!
ensureQuestionsExist 
	questionKeysToAsk ifEmpty: [
		questionKeysToAsk := questions keys asArray shuffled asOrderedCollection]! !

!DictionaryProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 11/5/2011 14:35'!
generateProblem
	self subclassResponsibility! !

!DictionaryProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/5/2011 16:06'!
initialize
	super initialize.
	questionKeysToAsk := #().
	questions := self questions! !

!DictionaryProblemGenerator methodsFor: 'helper' stamp: 'MathiasKegelmann 11/5/2011 14:38'!
nextQuestionAnswerAssociation 
	| question |
	self ensureQuestionsExist.
	question := questionKeysToAsk removeFirst.
	^ questions associationAt: question 
! !

!DictionaryProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/5/2011 16:08'!
questions
	self subclassResponsibility ! !

DictionaryProblemGenerator subclass: #SolidsProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Maths'!

!SolidsProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 11/5/2011 14:32'!
generateProblem 
	| assoc answer |
	assoc := self nextQuestionAnswerAssociation.
	answer := assoc value.
	^ NoeProblem text: assoc key 
		options: (self options: (1 to: 20) forAnswer: answer)
		answer: answer! !

!SolidsProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/19/2010 19:25'!
hardness
	^2! !

!SolidsProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/5/2011 16:06'!
questions
	^ Dictionary
		newFrom:
			{('Wie viele Ecken hat ein Wrfel?' -> 8).
			('Wie viele Ecken hat eine Pyramide?' -> 5).
			('Wie viele Ecken hat ein Prisma?' -> 6).
			('Wie viele Kanten hat ein Wrfel?' -> 12).
			('Wie viele Kanten hat eine Pyramide?' -> 8).
			('Wie viele Kanten hat ein Prisma?' -> 9).
			('Wie viele Flchen hat ein Wrfel?' -> 6).
			('Wie viele Flchen hat eine Pyramide?' -> 5).
			('Wie viele Flchen hat ein Prisma?' -> 5).
			('Wie viele Flchen hat ein Zylinder?' -> 3).
			('Wie viele Flchen hat ein Kegel?' -> 2).
			('Wie viele Kanten hat ein Zylinder?' -> 2).
			('Wie viele Kanten hat ein Kegel?' -> 1)}! !

AbstractProblemGenerator subclass: #GermanLatinConjugationProblemGenerator
	instanceVariableNames: 'wordPairs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!GermanLatinConjugationProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 11/6/2011 22:16'!
generateProblem 
	| germanLatin latin person |
	germanLatin := wordPairs atRandom.
	latin := germanLatin value.
	person := VerbPerson atRandom.
	^ NoeProblem 
		text: 'bersetze auf Latein: ', String cr, (person of: germanLatin key)
		options: (VerbPerson allFormsOf: latin) asArray shuffled   
		answer: (person of:  latin)! !

!GermanLatinConjugationProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 12:56'!
hardness 
	^ 2! !

!GermanLatinConjugationProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/6/2011 13:04'!
initialize
	super initialize.
	wordPairs :={
		(GermanVerb withRoot: 'lieb') -> (LatinVerbAConjugation withRoot: 'am') .
		(GermanVerb withRoot: 'ruf') -> (LatinVerbAConjugation withRoot: 'voc') .
		(GermanVerb withRoot: 'gehorch') -> (LatinVerbEConjugation withRoot: 'par') . 
		(GermanVerb withRoot: 'warn') -> (LatinVerbEConjugation withRoot: 'mon') .
		(GermanVerb withRoot: 'komm') -> (LatinVerbIConjugation withRoot: 'ven') .  
		(GermanVerb withRoot: 'hr') -> (LatinVerbIConjugation withRoot: 'aud')
	}! !

AbstractProblemGenerator subclass: #SquareProblemGenerator
	instanceVariableNames: 'randomSequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Maths'!

SquareProblemGenerator subclass: #ShuffledSquareProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Maths'!

!ShuffledSquareProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/6/2010 22:22'!
options 
	^ super options shuffled.! !

!SquareProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/6/2010 22:20'!
generateProblem
	| question answer |
	question := randomSequence next.
	answer := question * question.
	^ NoeProblem
		text: ('Was ist {1} mal {1}?' format: {question asString})
		options: self options
		answer: answer! !

!SquareProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/6/2010 15:16'!
initialize 
	self initialize: (NonDuplicateRandomSequence new: 10).! !

!SquareProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/6/2010 15:17'!
initialize: aRandomSequence 
	"a private constructor for tests"
	super initialize.
	randomSequence := aRandomSequence.! !

!SquareProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/6/2010 22:20'!
options
	^ (1 to: 10) collect: [ :x | x * x ]! !

AbstractProblemGenerator subclass: #WordProblemGenerator
	instanceVariableNames: 'names'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables'!

WordProblemGenerator subclass: #AbstractChangeProblemGenerator
	instanceVariableNames: 'shops'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Maths'!

!AbstractChangeProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 21:46'!
answerForEuros: euros AndCents: cents
	self subclassResponsibility ! !

!AbstractChangeProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 21:45'!
eurosToPay: euros
	self subclassResponsibility ! !

!AbstractChangeProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 11/5/2011 14:21'!
generateProblem
	| name shop answerCents centsToPay eurosCarried eurosToPay answerEuros |
	name := self randomName.
	shop := shops atRandom.
	answerCents := self nextRandomCents.
	centsToPay := 100 - answerCents.
	eurosCarried := self nextRandomEuro.
	eurosToPay := self eurosToPay: eurosCarried.
	answerEuros := eurosCarried - eurosToPay - 1.
	^ NoeProblem
		text:
			name , ' geht zum ' , shop , ' und muss ' , 
			   (self stringFromEuros: eurosToPay andCents: centsToPay), 
			   ' bezahlen. Sie hat ' , eurosCarried asString , 
			   ' Euros. Wie viel Wechselgeld bekommt sie?'
		options: (self optionsForAnswerEuros: answerEuros andCents: answerCents)
		answer: (self answerForEuros: answerEuros AndCents: answerCents)! !

!AbstractChangeProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/19/2010 21:17'!
hardness 
	^ 2! !

!AbstractChangeProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/19/2010 21:19'!
initialize 
	self initializeNames;
		initializeShops ! !

!AbstractChangeProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/19/2010 21:18'!
initializeShops
	shops := #('Bcker' 'Tengelmann' 'Metzger' 'Eisgeschft')! !

!AbstractChangeProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 21:45'!
nextRandomCents
	self subclassResponsibility ! !

!AbstractChangeProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 21:45'!
nextRandomEuro
	self subclassResponsibility ! !

!AbstractChangeProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 21:46'!
optionsForAnswerEuros: euros andCents: cents
	self subclassResponsibility ! !

!AbstractChangeProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 22:23'!
stringFromEuros: euros andCents: cents
	^(euros printPaddedWith: $0 to: 1), ',', (cents printPaddedWith: $0 to: 2), ' EUR'.! !

AbstractChangeProblemGenerator subclass: #ChangeBaseFiveProblemGenerator
	instanceVariableNames: 'randomCentsSequence randomEurosSequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Maths'!

!ChangeBaseFiveProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 22:30'!
answerForEuros: euros AndCents: cents
	^ self stringFromEuros: euros andCents: cents! !

!ChangeBaseFiveProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/20/2010 23:06'!
ensureRandomEurosSequenceNonEmpty
	randomEurosSequence ifEmpty: [
		randomEurosSequence := #(5 10 5 10 5 10 5 10 5 10) shuffled asOrderedCollection]! !

!ChangeBaseFiveProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 22:15'!
eurosToPay: euros
	^ euros - 5 atRandom.! !

!ChangeBaseFiveProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/19/2010 21:47'!
initialize 
	super initialize.
	self initializeRandomSequences ! !

!ChangeBaseFiveProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/20/2010 23:06'!
initializeRandomSequences
	randomCentsSequence := NonDuplicateRandomSequence new: 9.
	randomEurosSequence := #()! !

!ChangeBaseFiveProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 21:51'!
nextRandomCents
	^ randomCentsSequence next * 5! !

!ChangeBaseFiveProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/20/2010 23:05'!
nextRandomEuro
	self ensureRandomEurosSequenceNonEmpty.
	^ randomEurosSequence removeFirst ! !

!ChangeBaseFiveProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 22:27'!
optionsForAnswerEuros: euros andCents: cents
	| options |
	options := OrderedCollection new.
	(0 to: 4) do: [:e | (5 to: 45 by: 5) do: [ :c | 
			options add: (self stringFromEuros: e andCents: c)]].
	^ self options: options forAnswer: (self stringFromEuros: euros andCents: cents)! !

AbstractChangeProblemGenerator subclass: #FullChangeProblemGenerator
	instanceVariableNames: 'randomCentsSequence randomEurosSequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Maths'!

!FullChangeProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 22:40'!
answerForEuros: euros AndCents: cents
	^ self stringFromEuros: euros andCents: cents! !

!FullChangeProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/20/2010 23:04'!
ensureRandomEurosSequenceNonEmpty
	randomEurosSequence ifEmpty: [
		randomEurosSequence := #(5 10 5 10 5 10 2 4 6 8) shuffled asOrderedCollection]! !

!FullChangeProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 22:39'!
eurosToPay: euros
	euros \\ 5 = 0 ifTrue: [^ euros - 5 atRandom].
	^ euros - 2 atRandom.! !

!FullChangeProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/20/2010 23:08'!
hardness 
	^ 3! !

!FullChangeProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/19/2010 22:36'!
initialize 
	super initialize.
	self initializeRandomSequences ! !

!FullChangeProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/20/2010 23:04'!
initializeRandomSequences
	randomCentsSequence := NonDuplicateRandomSequence new: 99.
	randomEurosSequence := #()! !

!FullChangeProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 22:38'!
nextRandomCents
	^ randomCentsSequence next! !

!FullChangeProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/20/2010 23:04'!
nextRandomEuro
	self ensureRandomEurosSequenceNonEmpty.
	^ randomEurosSequence removeFirst ! !

!FullChangeProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 22:40'!
optionsForAnswerEuros: euros andCents: cents
	| options |
	options := OrderedCollection new.
	(0 to: 4) do: [:e | (1 to: 99) do: [ :c | 
			options add: (self stringFromEuros: e andCents: c)]].
	^ self options: options forAnswer: (self stringFromEuros: euros andCents: cents)! !

AbstractChangeProblemGenerator subclass: #SmallChangeBaseFiveProblemGenerator
	instanceVariableNames: 'randomCentsSequence randomEurosSequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Maths'!

!SmallChangeBaseFiveProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 22:31'!
answerForEuros: euros AndCents: cents
	^ cents asString , ' Cents'! !

!SmallChangeBaseFiveProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 21:29'!
eurosToPay: euros
	^ euros - 1.! !

!SmallChangeBaseFiveProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/19/2010 21:20'!
initialize 
	super initialize.
	self initializeRandomSequences ! !

!SmallChangeBaseFiveProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/19/2010 21:48'!
initializeRandomSequences
	randomCentsSequence := NonDuplicateRandomSequence new: 9.
	randomEurosSequence := NonDuplicateRandomSequence new: 7! !

!SmallChangeBaseFiveProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 21:36'!
nextRandomCents
	^ randomCentsSequence next * 5! !

!SmallChangeBaseFiveProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 21:30'!
nextRandomEuro
	^ randomEurosSequence next + 1! !

!SmallChangeBaseFiveProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/19/2010 21:40'!
optionsForAnswerEuros: euros andCents: cents
	^ (5 to: 45 by: 5) collect: [ :c | c asString , ' Cents' ]! !

WordProblemGenerator subclass: #AgeProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Maths'!

!AgeProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/20/2010 23:12'!
generateProblem
	| name age1 delta jahrText deltaText age2 geschwister sum |
	name := self randomName.
	age1 := 5 + 5 atRandom.
	delta := 4 atRandom.
	jahrText := delta > 1
		ifTrue: [ ' Jahre' ]
		ifFalse: [ ' Jahr' ].
	self randomBoolean
		ifTrue:
			[ age2 := age1 + delta.
			deltaText := ' lter' ]
		ifFalse:
			[ age2 := age1 - delta.
			deltaText := ' jnger' ].
	sum := age1 + age2.
	geschwister := self randomBoolean
		ifTrue: [ 'Ihr Bruder' ]
		ifFalse: [ 'Ihre Schwester' ].
	^ NoeProblem
		text: name , ' ist ' , age1 asString , '. ' , 
			geschwister , ' ist ' , delta asString , jahrText , deltaText, 
			'. Wie alt sind sie zusammen?'
		options: (self options: (8 to: 24) forAnswer: sum)
		answer: sum! !

!AgeProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/12/2010 07:24'!
hardness 
	^ 3.! !

!AgeProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/17/2010 22:51'!
initialize
	self initializeNames! !

WordProblemGenerator subclass: #AgeReverseProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Maths'!

!AgeReverseProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/20/2010 23:14'!
generateProblem
	| name age1 delta jahrText deltaText age2 geschwister sum |
	name := self randomName.
	age1 := 5 + 5 atRandom.
	delta := 4 atRandom.
	jahrText := delta > 1
		ifTrue: [ ' Jahre' ]
		ifFalse: [ ' Jahr' ].
	self randomBoolean
		ifTrue:
			[ age2 := age1 + delta.
			deltaText := ' lter' ]
		ifFalse:
			[ age2 := age1 - delta.
			deltaText := ' jnger' ].
	sum := age1 + age2.
	geschwister := self randomBoolean
		ifTrue: [ 'Ihr Bruder' ]
		ifFalse: [ 'Ihre Schwester' ].
	^ NoeProblem
		text: name , ' hat mehrere Geschwister. ' , 
			geschwister , ' ist ' , delta asString , jahrText , deltaText, 
			'. Zusammen sind sie ' , sum asString , 
			'. Wie alt ist ' , name , '?'
		options: (5 to: 10)
		answer: age1! !

!AgeReverseProblemGenerator methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/20/2010 23:10'!
hardness 
	^ 4.! !

!AgeReverseProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/20/2010 23:11'!
initialize
	self initializeNames! !

!WordProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/17/2010 23:46'!
initializeNames
	names := #(#Paula #Noemi #Anna #Martina #Susanne #Gabi #Elena #Luisa)! !

!WordProblemGenerator methodsFor: 'helper' stamp: 'MathiasKegelmann 11/5/2011 14:21'!
randomName
	^ names atRandom ! !

Object subclass: #CountDown
	instanceVariableNames: 'monitor timeoutBlock updateBlock startValue counter activeNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables'!

!CountDown methodsFor: 'private' stamp: 'MathiasKegelmann 3/11/2010 22:50'!
countDown
	| n |
	monitor critical: [
		counter := counter - 1.
		n := counter
		].
	n > 0 ifTrue: [self update: n] ifFalse: [self timeout].
	! !

!CountDown methodsFor: 'running' stamp: 'MathiasKegelmann 3/11/2010 22:02'!
countdownFrom: start onTimeoutDo: valueable
	self countdownFrom: start onTimeoutDo: valueable onUpdateDo: nil.! !

!CountDown methodsFor: 'running' stamp: 'MathiasKegelmann 3/11/2010 23:03'!
countdownFrom: start onTimeoutDo: aTimeoutBlock  onUpdateDo: anUpdateBlock 
	self stop.
	monitor critical: [
		startValue := start.
		timeoutBlock := aTimeoutBlock.
		updateBlock := anUpdateBlock.
	].
	self start.! !

!CountDown methodsFor: 'running' stamp: 'MathiasKegelmann 3/11/2010 22:57'!
countdownFrom: start target: target onTimeout: timeoutSymbol
	self countdownFrom: start onTimeoutDo: [target perform: timeoutSymbol].! !

!CountDown methodsFor: 'running' stamp: 'MathiasKegelmann 3/11/2010 23:00'!
countdownFrom: start target: target onTimeout: timeoutSymbol onUpdate: updateSymbol
	self countdownFrom: start 
		onTimeoutDo: [target perform: timeoutSymbol] 
		onUpdateDo: [:x | target perform: updateSymbol withArguments: {x}]! !

!CountDown methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/11/2010 22:25'!
initialize 
	monitor := Monitor new.
	activeNumber := 0.! !

!CountDown methodsFor: 'running' stamp: 'MathiasKegelmann 3/11/2010 23:03'!
restart
	self stop; start.! !

!CountDown methodsFor: 'private' stamp: 'MathiasKegelmann 3/11/2010 23:02'!
start
	| number |
	monitor critical: [
		self stepActiveNumber.
		number := activeNumber.
		counter := startValue ].
	[ monitor critical: [
		[ activeNumber = number ] whileTrue: [
			monitor waitMaxSeconds: 1.
			activeNumber = number ifTrue: [
				self countDown.]]]] fork.! !

!CountDown methodsFor: 'private' stamp: 'MathiasKegelmann 3/11/2010 22:47'!
stepActiveNumber
	monitor critical: [activeNumber := activeNumber + 1]

	! !

!CountDown methodsFor: 'running' stamp: 'MathiasKegelmann 3/11/2010 22:47'!
stop
	monitor critical: [
		self stepActiveNumber.
		monitor signal].

	! !

!CountDown methodsFor: 'event handling' stamp: 'MathiasKegelmann 3/11/2010 22:53'!
timeout
	self stop.
	timeoutBlock notNil ifTrue: [timeoutBlock value].
	! !

!CountDown methodsFor: 'event handling' stamp: 'MathiasKegelmann 3/11/2010 22:53'!
update: n
	updateBlock notNil ifTrue: [updateBlock value: n].
	! !

Object subclass: #InflectingNoun
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

InflectingNoun subclass: #GermanFeminineNoun
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!GermanFeminineNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:54'!
accusativePlural
	^ 'die ', self plural! !

!GermanFeminineNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:28'!
accusativeSingular
	^ 'die ', root! !

!GermanFeminineNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:54'!
dativePlural
	^ 'den ', self plural! !

!GermanFeminineNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:28'!
dativeSingular
	^ 'der ', root! !

!GermanFeminineNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:55'!
nominativePlural
	^ 'die ', self plural! !

!GermanFeminineNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:28'!
nominativeSingular
	^ 'die ', root! !

!GermanFeminineNoun methodsFor: 'private' stamp: 'MathiasKegelmann 11/6/2011 16:56'!
plural
	^ ((root endsWith: 'n') ifTrue: [root, 'n'] ifFalse: [root]), 'en'! !

!GermanFeminineNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:55'!
vocativePlural
	^ self plural! !

!GermanFeminineNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:26'!
vocativeSingular
	^ root! !

InflectingNoun subclass: #GermanMasculineENoun
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!GermanMasculineENoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:23'!
accusativePlural
	^ 'die ', root, 'e'! !

!GermanMasculineENoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:25'!
accusativeSingular
	^ 'den ', root! !

!GermanMasculineENoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:24'!
dativePlural
	^ 'den ', root, 'en'! !

!GermanMasculineENoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:25'!
dativeSingular
	^ 'dem ', root! !

!GermanMasculineENoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:23'!
nominativePlural
	^ 'die ', root, 'e'! !

!GermanMasculineENoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:25'!
nominativeSingular
	^ 'der ', root! !

!GermanMasculineENoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:24'!
vocativePlural
	^ root, 'e'! !

!GermanMasculineENoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:24'!
vocativeSingular
	^ root! !

GermanMasculineENoun subclass: #GermanNeuterENoun
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!GermanNeuterENoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:38'!
accusativeSingular
	^ 'das ', root! !

!GermanNeuterENoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:38'!
nominativeSingular
	^ 'das ', root! !

InflectingNoun subclass: #GermanMasculineFixedNoun
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!GermanMasculineFixedNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 08:52'!
accusativePlural
	^ 'die ', root! !

!GermanMasculineFixedNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 08:51'!
accusativeSingular
	^ 'den ', root! !

!GermanMasculineFixedNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 18:15'!
dativePlural
	^ 'den ', root, 'n'! !

!GermanMasculineFixedNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 08:51'!
dativeSingular
	^ 'dem ', root! !

!GermanMasculineFixedNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 08:53'!
nominativePlural
	^ 'die ', root! !

!GermanMasculineFixedNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 08:51'!
nominativeSingular
	^ 'der ', root! !

!GermanMasculineFixedNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 08:53'!
vocativePlural
	^ root! !

!GermanMasculineFixedNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 08:51'!
vocativeSingular
	^ root! !

InflectingNoun subclass: #GermanMasculineNNoun
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!GermanMasculineNNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 08:18'!
accusativePlural
	^ 'die ', self stem, 'n'! !

!GermanMasculineNNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 08:18'!
accusativeSingular
	^ 'den ', root, 'n'! !

!GermanMasculineNNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 08:18'!
dativePlural
	^ 'den ', self stem, 'n'! !

!GermanMasculineNNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 08:18'!
dativeSingular
	^ 'dem ', root, 'n'! !

!GermanMasculineNNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 08:51'!
nominativePlural
	^ 'die ', self stem, 'n'! !

!GermanMasculineNNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 08:18'!
nominativeSingular
	^ 'der ', root! !

!GermanMasculineNNoun methodsFor: 'private' stamp: 'MathiasKegelmann 11/7/2011 08:51'!
stem
	^ (root endsWith: 'e') ifTrue: [root] ifFalse: [root, 'e']! !

!GermanMasculineNNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 08:48'!
vocativePlural
	^ self stem, 'n'! !

!GermanMasculineNNoun methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/7/2011 08:18'!
vocativeSingular
	^ root! !

!InflectingNoun classSide methodsFor: 'instance creation' stamp: 'MathiasKegelmann 11/2/2011 17:37'!
withRoot: aByteString 
	^ self basicNew root: aByteString 
! !

!InflectingNoun methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/2/2011 17:38'!
root: aByteString 
	root := aByteString! !

InflectingNoun subclass: #LatinNounADeclension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!LatinNounADeclension methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 16:41'!
accusativePlural
	^root, 'as'! !

!LatinNounADeclension methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 16:41'!
accusativeSingular
	^root, 'am'! !

!LatinNounADeclension methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 16:36'!
dativePlural
	^root, 'is'! !

!LatinNounADeclension methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:19'!
dativeSingular
	^root, 'ae'! !

!LatinNounADeclension methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 16:41'!
nominativePlural
	^root, 'ae'! !

!LatinNounADeclension methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 16:41'!
nominativeSingular
	^root, 'a'! !

!LatinNounADeclension methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 16:41'!
vocativePlural
	^ self nominativePlural ! !

!LatinNounADeclension methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 16:42'!
vocativeSingular
	^ self nominativeSingular ! !

InflectingNoun subclass: #LatinNounODeclension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!LatinNounODeclension methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/2/2011 17:43'!
accusativePlural
	^root, 'os'! !

!LatinNounODeclension methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/2/2011 17:43'!
accusativeSingular
	^root, 'um'! !

!LatinNounODeclension methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/2/2011 17:44'!
dativePlural
	^root, 'is'! !

!LatinNounODeclension methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/2/2011 17:44'!
dativeSingular
	^root, 'o'! !

!LatinNounODeclension methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/2/2011 17:42'!
nominativePlural
	^root, 'i'! !

!LatinNounODeclension methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/2/2011 17:42'!
nominativeSingular
	^root, 'us'! !

!LatinNounODeclension methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/2/2011 17:44'!
vocativePlural
	^root, 'i'! !

!LatinNounODeclension methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 16:35'!
vocativeSingular
	^ (root last = $i)
		ifTrue: [root] 
		ifFalse: [root, 'e']! !

LatinNounODeclension subclass: #LatinNounODeclensionNeuter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!LatinNounODeclensionNeuter methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 16:40'!
accusativePlural
	^root, 'a'! !

!LatinNounODeclensionNeuter methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 16:40'!
nominativePlural
	^self accusativePlural ! !

!LatinNounODeclensionNeuter methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 16:40'!
nominativeSingular
	^self accusativeSingular 
	! !

!LatinNounODeclensionNeuter methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 16:40'!
vocativePlural
	^self nominativePlural ! !

!LatinNounODeclensionNeuter methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 16:41'!
vocativeSingular
	^ self nominativeSingular ! !

Object subclass: #InflectingVerb
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

InflectingVerb subclass: #GermanReflexiveVerbNoE
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!GermanReflexiveVerbNoE methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 23:21'!
firstPersonPlural
	^ 'wir ', root, 'n uns'! !

!GermanReflexiveVerbNoE methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 23:19'!
firstPersonSingular
	^ 'ich ', root, 'e mich'! !

!GermanReflexiveVerbNoE methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 23:19'!
imperativePlural
	^ self stem, 't euch!!'! !

!GermanReflexiveVerbNoE methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 23:19'!
imperativeSingular
	^ root, 'e dich!!'! !

!GermanReflexiveVerbNoE methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 23:21'!
infinitive
	^ 'sich ', root, 'n'! !

!GermanReflexiveVerbNoE methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 23:19'!
secondPersonPlural
	^ 'ihr ', self stem, 't euch'! !

!GermanReflexiveVerbNoE methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 23:19'!
secondPersonSingular
	^ 'du ', self stem, 'st dich'! !

!GermanReflexiveVerbNoE methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 23:19'!
stem
	^ root! !

!GermanReflexiveVerbNoE methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 23:21'!
thirdPersonPlural
	^ 'sie ', root, 'n sich'! !

!GermanReflexiveVerbNoE methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 23:20'!
thirdPersonSingular
	^ 'er, sie, es ', self stem, 't sich'! !

InflectingVerb subclass: #GermanVerb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!GermanVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 23:15'!
firstPersonPlural
	^ 'wir ', self infinitive ! !

!GermanVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 12:53'!
firstPersonSingular
	^ 'ich ', root, 'e'! !

!GermanVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 17:06'!
imperativePlural
	^ self stem, 't!!'! !

!GermanVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 12:54'!
imperativeSingular
	^ root, 'e!!'! !

!GermanVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 12:54'!
infinitive
	^ root, 'en'! !

!GermanVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 17:07'!
secondPersonPlural
	^ 'ihr ', self stem, 't'! !

!GermanVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 17:07'!
secondPersonSingular
	^ 'du ', self stem, 'st'! !

!GermanVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 17:07'!
stem
	^ (root endsWith: 't') ifTrue: [root, 'e'] ifFalse: [root]! !

!GermanVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 23:15'!
thirdPersonPlural
	^ 'sie ', self infinitive! !

!GermanVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 17:07'!
thirdPersonSingular
	^ 'er, sie, es ', self stem, 't'! !

GermanVerb subclass: #GermanVerbGeben
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!GermanVerbGeben methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/13/2011 20:09'!
imperativeSingular
	^ 'gib!!'! !

!GermanVerbGeben methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/7/2011 18:37'!
initialize
	super initialize.
	self root: 'geb'! !

!GermanVerbGeben methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/13/2011 20:09'!
secondPersonSingular
	^ 'du gibst'! !

!GermanVerbGeben methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/13/2011 20:10'!
thirdPersonSingular
	^ 'er, sie, es gibt'! !

!InflectingVerb classSide methodsFor: 'instance creation' stamp: 'MathiasKegelmann 11/6/2011 12:48'!
withRoot: aByteString 
	^ self basicNew root: aByteString 
! !

!InflectingVerb methodsFor: 'initialization' stamp: 'MathiasKegelmann 11/6/2011 12:48'!
root: aByteString 
	root := aByteString! !

InflectingVerb subclass: #LatinVerb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!LatinVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 12:49'!
firstPersonPlural
	^ self stem, 'mus'! !

!LatinVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 12:49'!
firstPersonSingular
	^ self stem, 'o'! !

!LatinVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 12:49'!
imperativePlural
	^ self stem, 'te'! !

!LatinVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 12:49'!
imperativeSingular
	^ self stem! !

!LatinVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 12:49'!
infinitive
	^ self stem, 're'! !

!LatinVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 12:49'!
secondPersonPlural
	^ self stem, 'tis'! !

!LatinVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 12:49'!
secondPersonSingular
	^ self stem, 's'! !

!LatinVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 12:50'!
stem
	self subclassResponsibility ! !

!LatinVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 12:49'!
thirdPersonPlural
	^ self stem, 'nt'! !

!LatinVerb methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 12:49'!
thirdPersonSingular
	^ self stem, 't'! !

LatinVerb subclass: #LatinVerbAConjugation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!LatinVerbAConjugation methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 18:19'!
firstPersonSingular
	^ root, 'o'! !

!LatinVerbAConjugation methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 18:24'!
stem
	^ root, 'a'! !

LatinVerb subclass: #LatinVerbEConjugation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!LatinVerbEConjugation methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 18:29'!
stem
	^ root, 'e'! !

LatinVerb subclass: #LatinVerbIConjugation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!LatinVerbIConjugation methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 18:30'!
stem
	^ root, 'i'! !

!LatinVerbIConjugation methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 18:35'!
thirdPersonPlural 
	^ self stem, 'unt'! !

Object subclass: #NoeLesson
	instanceVariableNames: 'problemGenerator correctCount lastProblem requiredCorrectAnswers levelChangeObserver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables'!

!NoeLesson commentStamp: 'MathiasKegelmann 11/13/2011 13:00' prior: 0!
I control how the lesson progresses. After seven correct answers in a row I ask the current problem generator for a new generator instance by sending #nextProblemGenerator.

Instance Variables
	problemGenerator:		the current ProblemGenerator
!

NoeLesson subclass: #NoeFlexibleLesson
	instanceVariableNames: 'problemGenerators generatorDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables'!

NoeFlexibleLesson class
	instanceVariableNames: 'problemGenerators'!

!NoeFlexibleLesson commentStamp: 'MathiasKegelmann 11/2/2011 13:54' prior: 0!
I allow a flexible configuration of problem generators. Rather than stepping up the level of one generator I go through a collection of generators. When a generator occurs twice in the list, then I call #nextLevel on the generator used previously.!

NoeFlexibleLesson class
	instanceVariableNames: 'problemGenerators'!

!NoeFlexibleLesson classSide methodsFor: 'instance creation' stamp: 'MathiasKegelmann 3/6/2010 16:31'!
newWithPlan: aProblemGeneratorsList
	^ self basicNew initializeWithPlan: aProblemGeneratorsList.! !

!NoeFlexibleLesson methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/6/2010 22:38'!
initializeWithPlan: aProblemGeneratorsList
	super initialize.
	problemGenerators := OrderedCollection withAll: aProblemGeneratorsList.
	generatorDictionary := Dictionary new.
	self problemGenerator: self nextProblemGenerator.! !

!NoeFlexibleLesson methodsFor: 'private' stamp: 'MathiasKegelmann 3/6/2010 22:49'!
nextProblemGenerator
	| generatorClass generator |
	problemGenerators isEmpty ifTrue: [ ^ nil ].
	generatorClass := problemGenerators removeFirst.
	generator  := (generatorDictionary includesKey: generatorClass)
		ifTrue: [ (generatorDictionary at: generatorClass) nextLevel ]
		ifFalse: [ generatorClass new].
	generatorDictionary at: generatorClass put: generator.
	^ generator.! !

!NoeLesson classSide methodsFor: 'instance creation' stamp: 'MathiasKegelmann 2/26/2010 23:11'!
newWithProblemGenerator: aProblemGenerator
	| lessonManager |
	lessonManager := self basicNew.
	lessonManager initializeWithProblemGenerator: aProblemGenerator.
	^ lessonManager.! !

!NoeLesson methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/13/2011 17:14'!
correctAnswersToNextLevel
	^ self requiredCorrectAnswers - correctCount ! !

!NoeLesson methodsFor: 'private' stamp: 'MathiasKegelmann 11/13/2011 17:10'!
countAnswerAndOptionallyAdvanceLevel
	correctCount := correctCount + 1.
	self correctAnswersToNextLevel <= 0 
		ifTrue: [ self nextLevel ]! !

!NoeLesson methodsFor: 'private' stamp: 'MathiasKegelmann 3/6/2010 23:01'!
defaultRequiredCorrectAnswers 
	^ 7.! !

!NoeLesson methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/12/2010 07:38'!
hardness
	^ problemGenerator hardness.! !

!NoeLesson methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/6/2010 22:56'!
initialize
	super initialize.
	requiredCorrectAnswers := self defaultRequiredCorrectAnswers.
	self resetCorrectCount.
	levelChangeObserver := [].! !

!NoeLesson methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/6/2010 16:34'!
initializeWithProblemGenerator: initialProblemGenerator 
	self 
		initialize;
		problemGenerator: initialProblemGenerator.	! !

!NoeLesson methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/6/2010 22:58'!
levelChangeObserver: aBlock
	levelChangeObserver := aBlock.! !

!NoeLesson methodsFor: 'private' stamp: 'MathiasKegelmann 3/6/2010 22:57'!
nextLevel
	self
		problemGenerator: self nextProblemGenerator;
		resetCorrectCount.
	problemGenerator notNil ifTrue: [levelChangeObserver value].! !

!NoeLesson methodsFor: 'stepping' stamp: 'MathiasKegelmann 3/6/2010 15:58'!
nextProblem
	lastProblem := problemGenerator isNil ifTrue: [nil ] 
		ifFalse: [ problemGenerator generateProblem ].
	^ lastProblem.! !

!NoeLesson methodsFor: 'stepping' stamp: 'MathiasKegelmann 3/6/2010 16:13'!
nextProblem: answerOk
	answerOk
		ifTrue:
			[ self countAnswerAndOptionallyAdvanceLevel.
			^ self nextProblem ]
		ifFalse:
			[ self resetCorrectCount.
			^ lastProblem ]! !

!NoeLesson methodsFor: 'private' stamp: 'MathiasKegelmann 3/6/2010 22:34'!
nextProblemGenerator
	^ problemGenerator nextLevel! !

!NoeLesson methodsFor: 'private' stamp: 'MathiasKegelmann 3/6/2010 16:34'!
problemGenerator: aProblemGenerator
	problemGenerator := aProblemGenerator.! !

!NoeLesson methodsFor: 'private' stamp: 'MathiasKegelmann 3/6/2010 16:28'!
requiredCorrectAnswers
	^ requiredCorrectAnswers.! !

!NoeLesson methodsFor: 'tests' stamp: 'MathiasKegelmann 3/6/2010 14:57'!
requiredCorrectAnswers: n
	requiredCorrectAnswers := n.! !

!NoeLesson methodsFor: 'private' stamp: 'MathiasKegelmann 2/26/2010 23:24'!
resetCorrectCount 
	correctCount := 0.! !

Object subclass: #NoeNonRandomSequence
	instanceVariableNames: 'sequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Tests'!

!NoeNonRandomSequence commentStamp: 'MathiasKegelmann 3/6/2010 15:19' prior: 0!
I produce the sequence 5, 4, 3, 2, 1.!

!NoeNonRandomSequence methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/6/2010 15:20'!
initialize 
	sequence := OrderedCollection withAll: #(5 4 3 2 1).! !

!NoeNonRandomSequence methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/6/2010 15:20'!
next
	^ sequence removeFirst.! !

Object subclass: #NoeProblem
	instanceVariableNames: 'answer options problemText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables'!

!NoeProblem commentStamp: 'MathiasKegelmann 11/7/2011 23:04' prior: 0!
I contain a multiple choice problem.
!

!NoeProblem classSide methodsFor: 'instance creation' stamp: 'MathiasKegelmann 3/6/2010 22:05'!
text: aProblemText options: anOptionsArray answer: anAnswer
	^ (NoeProblem new) text: aProblemText options: anOptionsArray  answer: anAnswer. ! !

!NoeProblem methodsFor: 'testing' stamp: 'MathiasKegelmann 2/20/2010 22:02'!
isCorrectAnswer: anAnswer
	^ answer = anAnswer.! !

!NoeProblem methodsFor: 'accessing' stamp: 'MathiasKegelmann 2/20/2010 21:57'!
options
	^ options! !

!NoeProblem methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/6/2010 22:05'!
text 
	^problemText.! !

!NoeProblem methodsFor: 'private' stamp: 'MathiasKegelmann 3/6/2010 22:05'!
text: aProblemText options: anOptionsArray answer:anExpectedAnswer
	problemText := aProblemText.
	options := anOptionsArray.
	answer := anExpectedAnswer.! !

Object subclass: #NoeStubProblemGenerator
	instanceVariableNames: 'n'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Tests'!

!NoeStubProblemGenerator commentStamp: 'MathiasKegelmann 3/6/2010 15:04' prior: 0!
I simply return 1, 2, 3, ... as "problems".
When #nextLevel is called I return myself and go to the next 100, e.g. starting with 101, 102, ...!

NoeStubProblemGenerator subclass: #NoeStubOneLevelProblemGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Tests'!

!NoeStubOneLevelProblemGenerator commentStamp: 'MathiasKegelmann 3/6/2010 16:00' prior: 0!
A NoeStubOneLevelProblemGenerator is basically a NoeStubProblemGenerator. It returns nil as next level, however.!

!NoeStubOneLevelProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/6/2010 15:59'!
nextLevel 
	^ nil.! !

!NoeStubProblemGenerator classSide methodsFor: 'instance creation' stamp: 'MathiasKegelmann 3/6/2010 17:44'!
newWithInitialValue: n
	^ self basicNew initialize: n.! !

!NoeStubProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/6/2010 14:00'!
generateProblem 
	|result|
	result := n.
	n := n + 1.
	^result.! !

!NoeStubProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/6/2010 17:41'!
initialize
	self initialize: 1.! !

!NoeStubProblemGenerator methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/6/2010 17:40'!
initialize: initialN
	super initialize.
	n := initialN.! !

!NoeStubProblemGenerator methodsFor: 'creation' stamp: 'MathiasKegelmann 3/6/2010 17:43'!
nextLevel 
	| newN |
	newN := (n // 100 + 1) * 100 + 1.
	^ self class newWithInitialValue: newN.! !

Object subclass: #NonDuplicateRandomSequence
	instanceVariableNames: 'sequence max'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables'!

!NonDuplicateRandomSequence commentStamp: 'MathiasKegelmann 3/5/2010 20:35' prior: 0!
I produce a random sequence of the numbers from 1 to a given max without repeating a number.

Instance Variables
	max:		<Object>
	sequence:		<Object>

max
	- xxxxx

sequence
	- xxxxx
!

!NonDuplicateRandomSequence classSide methodsFor: 'instance creation' stamp: 'MathiasKegelmann 3/5/2010 20:36'!
new: aMaximum
	^ self basicNew initialize: aMaximum.! !

!NonDuplicateRandomSequence methodsFor: 'private' stamp: 'MathiasKegelmann 3/5/2010 20:40'!
ensureNonEmptySequence 
	sequence isEmpty ifTrue: [
		sequence := (OrderedCollection withAll: (1 to: max)) shuffled.
	].! !

!NonDuplicateRandomSequence methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/6/2010 15:15'!
initialize: aMaximum
	super initialize.
	sequence := #().
	max := aMaximum.! !

!NonDuplicateRandomSequence methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/5/2010 20:38'!
next
	self ensureNonEmptySequence.
	^ sequence removeFirst. 
	! !

Object subclass: #NounVerbForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

NounVerbForm subclass: #NounCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

NounCase subclass: #AccusativePlural
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!AccusativePlural classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 17:33'!
displayName
	^ 'Akkusativ Plural'! !

NounCase subclass: #AccusativeSingular
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!AccusativeSingular classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 17:34'!
displayName
	^ 'Akkusativ Singular'! !

NounCase subclass: #DativePlural
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!DativePlural classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 17:34'!
displayName
	^ 'Dativ Plural'! !

NounCase subclass: #DativeSingular
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!DativeSingular classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 17:34'!
displayName
	^ 'Dativ Singular'! !

NounCase subclass: #NominativePlural
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!NominativePlural classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 17:34'!
displayName
	^ 'Nominativ Plural'! !

NounCase subclass: #NominativeSingular
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!NominativeSingular classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 17:34'!
displayName
	^ 'Nominativ Singular'! !

!NounCase classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 22:14'!
wordCategorySuperClass
	^ NounCase ! !

NounCase subclass: #VocativePlural
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!VocativePlural classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 21:06'!
displayName
	^ 'Vocativ Plural'! !

NounCase subclass: #VocativeSingular
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!VocativeSingular classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 21:06'!
displayName
	^ 'Vocativ Singular'! !

!NounVerbForm classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/12/2011 17:01'!
allFormWordPairsOf: word
	^ (self wordCategorySuperClass subclasses collect: [:form | {form . form of: word}]) asSet
! !

!NounVerbForm classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 22:15'!
allFormsOf: word
	^ (self wordCategorySuperClass subclasses collect: [:form | form of: word]) asSet
! !

!NounVerbForm classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 20:11'!
atRandom
	^ self subclasses atRandom! !

!NounVerbForm classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 20:12'!
displayName
	self subclassResponsibility ! !

!NounVerbForm classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 20:11'!
of: word
	^word perform: (self selector)! !

!NounVerbForm classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 20:11'!
selector
	| n |
	n := self asString.
	^ ((n first asString asLowercase), (n allButFirst)) asSymbol ! !

!NounVerbForm classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 22:14'!
wordCategorySuperClass
	self subclassResponsibility ! !

NounVerbForm subclass: #VerbPerson
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

VerbPerson subclass: #FirstPersonPlural
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!FirstPersonPlural classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 20:17'!
displayName
	^ '1. Person Plural'! !

VerbPerson subclass: #FirstPersonSingular
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!FirstPersonSingular classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 20:18'!
displayName
	^ '1. Person Singular'! !

VerbPerson subclass: #ImperativePlural
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!ImperativePlural classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 20:19'!
displayName
	^ 'Imperativ Plural'! !

!ImperativePlural classSide methodsFor: 'testing' stamp: 'MathiasKegelmann 11/6/2011 16:03'!
isNormal 
	^false.! !

VerbPerson subclass: #ImperativeSingular
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!ImperativeSingular classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 20:19'!
displayName
	^ 'Imperativ Singular'! !

!ImperativeSingular classSide methodsFor: 'testing' stamp: 'MathiasKegelmann 11/6/2011 16:04'!
isNormal 
	^false.! !

VerbPerson subclass: #Infinitive
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!Infinitive classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 20:19'!
displayName
	^ 'Infinitiv'! !

!Infinitive classSide methodsFor: 'testing' stamp: 'MathiasKegelmann 11/6/2011 16:04'!
isNormal 
	^false.! !

VerbPerson subclass: #SecondPersonPlural
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!SecondPersonPlural classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 20:19'!
displayName
	^ '2. Person Plural'! !

VerbPerson subclass: #SecondPersonSingular
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!SecondPersonSingular classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 20:19'!
displayName
	^ '2. Person Singular'! !

VerbPerson subclass: #ThirdPersonPlural
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!ThirdPersonPlural classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 20:19'!
displayName
	^ '3. Person Plural'! !

VerbPerson subclass: #ThirdPersonSingular
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NoeTables-Latin'!

!ThirdPersonSingular classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/5/2011 20:20'!
displayName
	^ '3. Person Singular'! !

!VerbPerson classSide methodsFor: 'testing' stamp: 'MathiasKegelmann 11/6/2011 16:03'!
isNormal
	"Is this a 'normal' 1st, 2nd or 3rd person?'"
	^ true! !

!VerbPerson classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 16:10'!
normalPersonAtRandom
	^ (self subclasses select: [:person | person isNormal]) atRandom! !

!VerbPerson classSide methodsFor: 'accessing' stamp: 'MathiasKegelmann 11/6/2011 22:15'!
wordCategorySuperClass
	^ VerbPerson  ! !
